#!/usr/bin/perl -w


###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################



use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use strict;
use vars qw(%LSC %funktionen %require $LSCPackagePfad $q $scriptname);


require "lsc_pfad.pl";

$CGI::DISABLE_UPLOADS   = 1;
$CGI::POST_MAX          = 1024*10;
$q = new CGI;
$scriptname = script_name();

%funktionen = (
	''			=> \&StartSeite,
	'login'			=> \&AdminLigenZeigen,
	'logout'		=> \&AdminLigenZeigen,
	'test'			=> \&AdminLigaScriptTest,	
	'AddTeams'		=> \&AddTeams,
	'CreateTeams'		=> \&AdminCreateTeams,
	'TeamGroups'		=> \&AdminTeamGroups,
	'TeamUser',		=> \&AdminTeamUser,
	'Games'			=> \&AdminGames,

	'NewGame'		=> \&AdminNeuesSpiel,
	'NewGameF'		=> \&AdminNeuesSpielForderung,
	
	'ChangeGame'		=> \&AdminSpielmanipulieren,
	'DeleteAllGames'	=> \&AdminAlleErgebnissEinesTeamsLoeschen,
	'DeleteAllLeagueGames' =>	\&AdminAlleErgebnisseDerLigaLoeschen,
	'DeleteUploads' => \&AdminDeleteOldUploads,
	'Global'		=> \&AdminGlobal,
	'CreatePlayoffs' 	=> \&AdminPlayoffsErstellen,
	'DeletePlayoffRound'	=> \&AdminDeletePlayoffRound,
	'Playoff_DE_Delete_Team_Pos'	=> \&AdminPlayoffs_DoubleElimination_Delete_Team_Pos,
	'Playoff_DE_Add_Team_Pos'		=> \&AdminPlayoffs_DoubleElimination_Add_Team_Pos,
	'TeamVerwarnen'		=> \&AdminTeamVerwarnen,
	'UserVerwarnen'		=> \&AdminUserVerwarnen,
	'User'			=> \&AdminUserVerwalten,
	'Team'			=> \&AdminTeamVerwalten,
	'TeamInfo'		=> \&AdminTeamVerwalten2,
	'Teams'			=> \&AdminListTeams,

	
	'C_Tabelle'			=> \&AdminTabelle,
	'C_Maps'			=> \&AdminMapListe,
	'C_Admins'			=> \&AdminAdminStatus,
	'C_TabelleFarben'	=> \&AdminTabellenFarben,
	'C_SpielplanInit'	=> \&AdminSpielplanInitialisierung,
	'C_SpielplanModif'	=> \&AdminSpielplanModifizierung,
	'C_SpielplanStart'	=> \&AdminSpielplanErstellenBeenden,
	'C_SpielplanEnde'	=> \&AdminSpielplanErstellenBeenden,

	'TeamUpdate'		=> \&AdminTeamDatenAktualisieren,

	'DeleteGameComment'	=> \&AdminDeleteGameComment,

	'DeleteLeague'		=> \&AdminLigaLoeschen,

	'Votes'				=> \&VotesAdmin,

	'Statistic'			=> \&PageStats,

	'SupportTicket'		=> \&SupportTicketShowAdmin
);

%require = (
	'SupportTicket' => 'LSCSupportTicket.pm',
	
);
my %NoLeague = qw(
	Global		1
	User		1
	Team		1
	TeamInfo	1
	Teams		1
	Votes		1
	Statistic	1
	SupportTicket 1
);

$LSC{Funktionen} = "Admin";
require $LSCPackagePfad."LSCInit.pm";

if ($LSC{PlayerStats}) {
	$funktionen{'PlayerAdmin_PlayerTeams'} = \&PlayerAdmin_PlayerTeams;
}

Require("LSCAdminAll.pm");


# Main #
if ($q->cgi_error) {
	&LayoutEins;
	print $LSC{TEXT}{ERROR}[10].br;
	&LayoutZwei;
} elsif ($LSC{LOGIN}) {
	if ($LSC{Admin}) {
		HauptMenue();
	} else {
		&LayoutEins;
		AdminLigenZeigen();
		&LayoutZwei;
	}
} elsif ($LSC{Action} eq 'LostPassword') {
	&LayoutEins;
	Session('LostPassword');
	&LayoutZwei;

} else {
	my $Session;
	if (($Session = Session('Login')) eq 1) {
		HauptMenue();
	} else {
		&LayoutEins;
		print $Session;
		&LayoutZwei;
	}
}
MySQLDisconnect($LSC{MySQL}); #in Init initialisiert
exit(0);
# /Main #

sub HauptMenue {
	if ($LSC{Admin}) {
		&LayoutEins;
			if ($LSC{LeagueData}{Name}) {
				print "<div class=LeagueHeadline>".ShowLink({Name=>"/Home", Script=>$LSC{show_pl}, Class=>"HeadlineLink", League=>""}).(ShowLink({Name=>"/".$LSC{LeagueData}{Name}, Script=>"show.pl", Class=>"HeadlineLink", League=>$LSC{League}}) || 'LigaScript')."</div>".br.br;
			} else {
				print "<div class=LeagueHeadline>LigaScript Admin:</div>".br.br;
			}
			DoUserAction();
			if (!$LSC{LeagueData}{Name}) {
	                        print '<div>Version 2.2.0<br/>Available Version: <iframe style="width: 50px; height: 25px;" scrolling="no" frameborder="0" src="http://www.ihoax.de/projects/leaguescript/update.php"></iframe></div>';
                        }

		&LayoutZwei;
		return;
	}
	print $q->redirect("admin.pl");
}
sub DoUserAction {
	if ($funktionen{$LSC{Action}}) {
			if ($LSC{ligavorhanden}) { 
				if ($require{$LSC{Action}}) {
					Require("$require{$LSC{Action}}");
				}
				$funktionen{$LSC{Action}}->($LSC{Action2}, $LSC{special});
				return 1;
			} elsif ($NoLeague{$LSC{Action}}) {
				if ($require{$LSC{Action}}) {
					Require("$require{$LSC{Action}}");
				}
				$funktionen{$LSC{Action}}->($LSC{Action2}, $LSC{special});
				return 1;
			} elsif ($LSC{Action} eq '') {
				$funktionen{$LSC{Action}}->($LSC{Action2}, $LSC{special});
				return 1;
			} else {
				print "Um diese Funktionen nutzen zu knnen, muss eine Liga ausgewhlt worden sein!".br;
				return
			}
	} 
	print "Diese Funktion ist nicht verfgbar!".br;
	return;
}

## admin tools
# AddTeams
# AdminCreateTeams
# AdminTeamGroups
# AdminTeamUser
# AdminLigenZeigen
# StartSeite
# AdminNeuesSpiel
# AdminSpielLoeschen
# AdminSpielmanipulieren
# AdminLigaStatus
# AdminPlayoffsErstellen
sub AdminCreateTeams {
	unless ($LSC{LeagueData}{MJoin} == 3) {
		print "Diese Funktion steht fr diese Liga nicht zur Verfgung!".br;
		return;
	}
	
	print "<b>Teams fr die Liga Erstellen:</b>".br.br;
	
	if ($q->param('Create Teams')) {
		Require("LSCuser.create.pm");
		foreach my $T (split(/\n/,$q->param('Teams'))) {
			chomp($T);
			chop($T) if $T=~/\r/;
			if ($T) {
				print " - #$T ";
				my $id = TeamErstellen($T, 0, 1);
				_JoinLeagueTeam($id);
				print "erstellt.".br;
			}
		}
		print hr;
	}
	if ($q->param('Delete Team')) {
		Require("LSCuser.create.pm");
		_LeaveLeagueTeam($q->param('Team'));
		TeamLoeschen($q->param('Team'));	
		print "Team gelscht.".br;
		print hr;
	}
	
	
	print "Mehrere Teams gleichzeitig erstellen:".br;
	print " - pro Zeile einen Teamnamen einfgen".br;
	print br;
	print start_form('post',"$scriptname?League=$LSC{League}&Action=CreateTeams");
	print "TeamID's:", br, $q->textarea('Teams',"",10,30);
	print submit('Create Teams'),end_form;
	print br.br.br;
	
	print "Teams lschen:".br;
	print "- ACHTUNG!!! Wenn Teams nach dem Ligastart gelscht werden, dann kann sich die Tabelle der
	restlichen Teams verndern, weil die Ergebnisse des gelschten Teams verschwinden!!!".br;
	
	my %Members = Members();
	print start_form('post',"$scriptname?League=$LSC{League}&Action=CreateTeams");
	print $q->popup_menu(-name=>'Team', -values=>[sort {"\L$Members{$a}" cmp
			"\L$Members{$b}" } keys %Members], -Labels=>\%Members), "   ";
	print submit('Delete Team'),end_form;


}
sub AdminTeamGroups {
	if ($LSC{LeagueData}{MJoin} != 3 && $LSC{LeagueData}{MJoin} != 1) {
		print "Funktion nicht verfgbar!".br;
		return;
	}

	if ($q->param('Change Group')) {

		my $Team = $LSC{MySQL}->quote($q->param('Team'));
		my $MG = $LSC{MySQL}->quote($q->param('Main_Group'));
		my $SG = $LSC{MySQL}->quote($q->param('Sub_Group'));
		my $sth = $LSC{MySQL}->do("update lsc_teams_league set Main_Group=$MG, Sub_Group=$SG where Team=$Team and League=$LSC{League}");


	}


	my %Members = Members();
	my %GRoups = TeamGroups();
	print start_form('post',"$scriptname?League=$LSC{League}&Action=TeamGroups");
	print "<table><tr><td>Team</td><td>Main Group</td><td>Sub Group</td></tr>";

	my ($select,$from,$where,$group,$order);
		my $id = $LSC{MySQL}->quote($_[0]);
		$select	= "t.ID, t.Name, g1.Name, g2.Name";
		$from	= "lsc_teams_league l, lsc_teams_groups g1, lsc_teams_groups g2, lsc_teams t";
		$where	= "l.League=$LSC{League} and l.Team=t.ID and g1.ID=l.Main_Group and g2.ID=l.Sub_Group";
		$group	= "group by t.ID";
		$order	= "order by t.Name";

		
		
		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
		$sth->execute();
		while (my $ref = $sth->fetchrow_arrayref()) {
			print "<tr><td>$ref->[1]</td><td>$ref->[2]</td><td>$ref->[3]</td></tr>";
		}
		$sth->finish;
	
	print "<tr><td>".$q->popup_menu(-name=>'Team', -values=>[sort {"\L$Members{$a}" cmp
			"\L$Members{$b}" } keys %Members], -Labels=>\%Members).
			"</td><td>".$q->popup_menu(-name=>'Main_Group', -values=>[sort {"\L$GRoups{$a}" cmp
			"\L$GRoups{$b}" } keys %GRoups], -Labels=>\%GRoups).
			"</td><td>".$q->popup_menu(-name=>'Sub_Group', -values=>[sort {"\L$GRoups{$a}" cmp
			"\L$GRoups{$b}" } keys %GRoups], -Labels=>\%GRoups)."</td></tr>";
	print "</table>";
	print submit('Change Group'),end_form;
	
}
sub AdminTeamUser {
	unless ($LSC{LeagueData}{MJoin} == 3) {
		print "Funtkion nicht verfgbar!".br;
		return;
	}
	
	print "Hier kannst Du den erstellten Teams User zuordnen.".br.br;
	my $id;
	
	my %Members = Members();
	if ($q->param('save')) {
		if ($q->param('Team') && $q->param('user')) {

			if (!($q->param('Team')=~/[^0-9]/) && !($q->param('user')=~/[^0-9]/)
				&& $Members{$q->param('Team')}) {
				my $sth = $LSC{MySQL}->do("update lsc_teams set User=".$q->param('user')." 
					where ID=".$q->param('Team'))
			}
		}	
			
	
	} 
	if ($q->param('delete')) {
		if ($q->param('Team')) {
			if (!($q->param('Team')=~/[^0-9]/) && $Members{$q->param('Team')}) {
				my $sth = $LSC{MySQL}->do("update lsc_teams set User=0 
					where ID=".$q->param('Team'))
			}
		}	
			
	
	} 
	if (($id=TeamSuchen('admin.pl', 'TeamUser', 2))) {
		my ($userteamid, $userteam) = UserTeamIDTeamnameErmitteln($id);
		if ($userteamid) {
			print "Dieser User hat bereits ein Team in dieser Liga!";
		} else {
			#my $User = UserFromTeam($id);
			if ($id) {
				my $name = NameFromUserID($id);
				print hr;
				print start_form('post',"$scriptname?League=$LSC{League}&Action=TeamUser");
				print $q->hidden('user', $id);
				print "User: $name".br.br;	
				print "Team zuordnen: ";
				print $q->popup_menu(-name=>'Team', -values=>[sort {"\L$Members{$a}" cmp
				"\L$Members{$b}" } keys %Members], -Labels=>\%Members);
				print submit('save'),end_form;
				print hr;
			} else {
				print "User konnte nicht ermittelt werden. Sollte der Fehler hufiger auftrehten, wende
				dich bitte an mich. Danke".br;
			}			
		}
	}
	
	print hr;
	print "<b>Teams:</b>".br;
	print "<table><tr><td>ID</td><td>Team</td><td>User</td></tr>";
	foreach my $M (sort {"\L$Members{$a}" cmp "\L$Members{$b}" } keys %Members) {
	
		my $user = UserFromTeam($M);
		$user = $user ? (NameFromUserID($user) || 'no') : 'no';
		print "<tr><td>$M</td><td>$Members{$M}</td><td>$user</td>";
		if ($user ne 'no') {
			print "<td>";
			print start_form('post',"$scriptname?League=$LSC{League}&Action=TeamUser");
			print $q->hidden('Team', $M);
			print submit('delete'),end_form;		
			print "</td>";
		}
		print "</tr>";
	}
	print '</table>';
		
}
sub AdminLigenZeigen {
	my ($select,$from,$where,$group,$order);

	## alle ligen laden
	
	$select	= "L.League, L.Name, L.Status, L.MJoin, gs.Name";
	$from	= "lsc_leagues L, lsc_leagues_groups gs, lsc_leagues_group g";
	$where	= "L.League=g.League and g.ID=gs.ID";
	$group	= "";
	$order	= "Order By gs.ID, L.Name";

	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $old = '';
	print "Alle Ligen, in denen du Admin Status hast:".br;
	print "<table border=0>
		<tr><td>ID</td><td>Name</td></tr>
		\n";
	my $league = $LSC{League};
	while (my $ref = $sth->fetchrow_arrayref()) {
		$LSC{League} = $ref->[0];
		if ($LSC{UserStatus} == 9 || IsAnAdminForThisLeague($LSC{userid})) {
			#Funktion MainGroup
			if ($old ne $ref->[4]) {
				$old = $ref->[4];
				print "<tr>
					<td>#</td><td>$ref->[4]</td>
					</tr>";
			}
			
			#Ausgeben
			print "<tr>
				<td align=right>$ref->[0]</td><td><a class=LigaLink href=admin.pl?League=$ref->[0]>$ref->[1]</a></td>
				</tr>";
		}
	}
	$sth->finish;
	print "</table>\n";
}
sub StartSeite {
	if ($LSC{ligavorhanden}) {
		print "Auf der linken Seite, im unteren Men, findest Du nun Menpunkte, um deine Liga ($LSC{LeagueData}{Name}) zu verwalten.".br;
		print br;
		print br;
		print "<b>Beispiele:</b>",br;
		print "<b>* Change Game:</b>",br;
		print "- Hat ein Spiel stattgefunden, soll aber, wegen einem Regelverstoss, anders gewertet werden, dann knnen hier direkt die Werte manipuliert werden. Hat z.B. A gegen B gewonnen, wobei A gegen eine Regel verstossen hat, die Strafpunkte zur Folge hat, so zieht man einfach von den angegeben Ligapunkten(LP) die Strafpunkte ab und trgt die neuen Ligapunkte ein, dabei sind auch negative Ligapunkte mglich.".br;
		print "- Wurde eine Begegnung nicht gespielt, weil sich z.B. die beiden Spieler nicht auf ein Spieltermin einigen konnten, so trgt man zunchst ber 'Add Game' ein neues Spiel, ruft dann die Seite 'Change Game' auf und setzt die Werte fr 'Won', 'Lost' und 'Draw' auf 0, dadurch wird dieses Ergebnis nicht als Sieg, Niederlage oder Unentschieden gewertet. Nun kann man noch in der Spalte Ligapunkte(LP) Strafpunkte (Minuswerte) verteilen.".br;
		print "- Default Win... tritt ein Spieler nicht zum Spiel an, so kann ein Admin ber 'Add Game' ein Spiel eintragen und es danach ber 'Change Game' so verndern, dass den 'eigenen' Regeln entsprechend, Punkte verteilt werden, bzw. abgezogen werden.".br;
		print br.br;		
		print 'Solltest du an weiteren Funktionen interessiert sein, schicke mir eine Email an <a href=mailto:ligascript.adminfunktionen@leagues.ihoax.de>ligascript.adminfunktionen@leagues.ihoax.de</a>.';
	} else {
		AdminLigenZeigen();
	}
}
sub AdminDeletePlayoffRound {
	if ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'} && (my $r = PlayoffAktuelleRunde())) {
		if ($q->param('delete') eq 'LOESCHEN') {
			Require("LSCplayoff.create.pm");
			PlayoffRundeLoeschen($r);
		} else {
			print "nicht mglich".br;
		}
	}
}
sub AdminPlayoffsErstellen {
	
	unless ($LSC{LeagueData}{PlayoffDaten}) {
		print "Diese Funktion steht fr diese Liga nicht zur Verfgung!".br;
		return;
	}
	if (Liga_AnzahlSpiele($LSC{League}) && !$LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'}) {
		print "Es wurden bereits Spiele fr dieses Turnier eingetragen, deshalb
			knnen die Turniereinstellungen nicht mehr verndert werden!".br;
		return;
	}
	my $AnzahlTeams = $q->param('AnzahlTeams');
	my %MAnzahl = qw(1 1 2 1 4 1 8 1 16 1 32 1 64 1 128 1);
	
	if (!$AnzahlTeams || $AnzahlTeams=~/[^0-9]/ || !$MAnzahl{$AnzahlTeams}) {
		print "Bitte die Gre des Turniers whlen:".br;
		print start_form('post',"$scriptname?League=$LSC{League}&Action=CreatePlayoffs").br;
		print $q->popup_menu(-name=>"AnzahlTeams", -values=>[1,2,4,8,16,32, 64, 128]), "&nbsp; ";
		if ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'}) {
			print "Spiele in der nchsten Runde (".(PlayoffAktuelleRunde()+1).". Runde)".br;
			print "Achtung!!! Ab dem erstellen der 2. Runde wird automatisch die vorherige Runde beendet!";
		} elsif	($LSC{LeagueData}{PlayoffDaten}{'DoubleElimination'}) {
			print "Paarungen in der 1. Runde";
		} elsif ($LSC{LeagueData}{PlayoffDaten}) {
			print "Teams";
		}
		print br.br;
		print submit('Teamwahl'),end_form.br.br;
		
		if ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'} && PlayoffAktuelleRunde()) {
			print start_form('post',"$scriptname?League=$LSC{League}&Action=DeletePlayoffRound").br;
			print "Aktuelle Playoffrunde lschen!".br.br;
			print "Hier -> ".$q->textfield('delete', '', 10). " LOESCHEN eintragen".br;
			print submit('lschen'),end_form.br.br;
		}
	} else {
		Require("LSCplayoff.create.pm");
		PlayoffErstellen($AnzahlTeams, @_);
	}
}
sub AdminGlobal {
	if ($LSC{ligavorhanden}) { 
		print "Hier knnen alle Ligadaten festgelegt werden!".br;
		print "Bitte beachte beim ndern der Daten die Informationen, die jeweils angegeben sind. ";
		print "Ausserdem ist zu beachten, dass das verndern der Daten nachdem die Liga gestartet ist, nicht dazu
		fhrt, dass die bisher eingetragenen Ergebnisse verndert werden! Vernderungen der Daten gelten immer nur
		fr Zuknftige Spiele!".br.br;
		print hr;
		print "<table>";
		print "<tr><td><A HREF=\"admin.pl?League=$LSC{League}&Action=C_Tabelle\">Darstellung/Konfiguration der Tabelle</A></td></tr>";
		print "<tr><td><A HREF=\"admin.pl?League=$LSC{League}&Action=C_TabelleFarben\">Zeilenfarben der Tabelle</A></td><td>(full version only)</td></tr>" 
			if $LSC{Version};
		print "<tr><td><A HREF=\"admin.pl?League=$LSC{League}&Action=C_Admins\">LigaAdmins verwalten</A></td></tr>";
		print "<tr><td><A HREF=\"admin.pl?League=$LSC{League}&Action=DeleteLeague\">Liga lschen</A></td></tr>" 
			if $LSC{Version};
		print "<tr><td><A HREF=\"admin.pl?League=$LSC{League}&Action=C_Maps\">Map/Team-Liste erstellen/verwalten</A></td></tr>";
		print "</table>";
		my $AnzahlSpiele = Liga_AnzahlSpiele($LSC{League});
		my $AnzahlUser 	= Liga_AnzahlteilnehmenderUser($LSC{League});
		
		print hr;

		print "<div class=Headline>SPIELPAN:</div>".br;
		if ($LSC{Version}) {
			if ($LSC{LeagueData}{Spielplan}) {
				print "<A HREF=\"admin.pl?League=$LSC{League}&Action=C_SpielplanEnde\">Spielplan lschen/keinen Spielplan nutzen</A>".br.br;
				print "- Aktuellen Spieltag festlegen".br;
				if ($q->param('Spieltag speichern')) {
					my $st = $LSC{MySQL}->quote($q->param('Spieltag'));
					my $sth = $LSC{MySQL}->do("replace into lsc_leagues_spieltag (League, Spieltag) Values
					($LSC{League}, $st)");
					print "Spieltag wurde gespeichert.".br;
				} 
				print start_form('post',"$scriptname?League=$LSC{League}&Action=Global");
					print $q->textfield('Spieltag', $LSC{Spieltag});
					print submit('Spieltag speichern').end_form.br;
			
				print "<A HREF=\"admin.pl?League=$LSC{League}&Action=C_SpielplanInit\">Spielplan-Initialisierung</A>".br;
				print "<A HREF=\"admin.pl?League=$LSC{League}&Action=C_SpielplanModif\">Spielplan-Modifizieren</A>".br;
				print hr;
			} else {
				print "<A HREF=\"admin.pl?League=$LSC{League}&Action=C_SpielplanStart\">Spielplan erstellen/einen Spielplan nutzen</A>".br;
			}
		} else {
			print "Spielplne werden nur in der Vollversion untersttzt.".br;
		}

		print hr;
		
		if ($LSC{PlayoffScriptevorhanden}) {
			print "<div class=Headline>Turnier:</div>".br;
			my @Playoff = ("Kein Turnier gewhlt", '(2 Games_Draw) entspricht dem Uefapokal-Modus', 'Best Of Serie',	'Pokal-Modus, entspricht dem DFB-PokalModus, nach jeder Runde neue Paarungen festlegen',	'Double Elimination, mit abwechselnt gerader und gekreuzter Vertauschung zwischen Winner- und Looserbracket');
			print "<b>Aktuell gewhlter Turniermodus: </b><br>".$Playoff[$LSC{LeagueData}{Playoff} || 0].br.br;
			if ($LSC{LeagueData}{Playoff}) {
				print "<A HREF=\"admin.pl?League=$LSC{League}&Action=CreatePlayoffs\">Turnier erstellen</A>".br.br;
			}
			if ($AnzahlSpiele || $LSC{LeagueData}{Spielplan}) {
				print "Der Turniermodus kann nur gewechselt werden, wenn noch keine Ergebnisse eingetragen wurden und kein Spielplan gewhlt wurde!".br;
			} else {
				#ndern
				print "Turniermodus whlen:".br;
				if (defined $q->param('Playoff')) {
					if ($LSC{LeagueData}{Playoff}) {
						# alte einstellungen lschen
						$LSC{MySQL}->do("delete from lsc_playoffs WHERE League=$LSC{League}");	
						$LSC{MySQL}->do("delete from lsc_playoffs_bestof WHERE League=$LSC{League}");	
						$LSC{MySQL}->do("delete from lsc_playoffs_round WHERE League=$LSC{League}");	
					}
					my $p = $LSC{MySQL}->quote($q->param('Playoff'));
					my $sth = $LSC{MySQL}->do("update lsc_leagues set Playoff=$p where League=$LSC{League}");
					print "Turniermodus wurde gendert.".br.br;
					print "ACHTUNG!!!! Bitte einmal auf [Einstellungen] klicken um die Seite zu aktualisieren!".br;
				} else {
					print start_form('post',"$scriptname?League=$LSC{League}&Action=Global");
						print $q->popup_menu(-name=>"Playoff", -values=>[0..4] , -Labels=>{0=>"Kein Turniermodus", 1=>'2 Games Draw', 2=>'Best Of',	3=>'Pokal Best Of',	4=>'Double Elimination'});
					print submit('Modus wechseln').end_form.br;
				}
			}
			print hr;
		}


		print "<div class=Headline>Liga Status:</div>".br;
		if ($q->param('close League')) {
			my $sth = $LSC{MySQL}->do("update lsc_leagues set Status=2 where League=$LSC{League}");
			print "League closed.";
		} elsif ($q->param('open League')) {
			my $sth = $LSC{MySQL}->do("update lsc_leagues set Status=1 where League=$LSC{League}");
			print "League opened.";
		} else {
			print "<b>League Status</b>:".br.br;
			if ($LSC{LeagueData}{Status} == 1 ) {
				print start_form('post',"admin.pl?League=$LSC{League}&Action=Global");
				print "Liga schliessen, es knnen keine Ergebnisse mehr eingetragen werden: ";
				print submit('close League'),end_form;
			} elsif (!$LSC{LeagueData}{Status} || $LSC{LeagueData}{Status} == 2) {
				print start_form('post',"admin.pl?League=$LSC{League}&Action=Global");
				print "Liga oeffnen, es knnen Ergebnisse eingetragen werden: ";
				print submit('open League'),end_form;
			} else {
				print "unbekannter Ligastatus! $LSC{Status}";
			}
		}

		print hr;

		print "<div class=Headline>Members:</div>".br;
		print "all = Jeder im Ligascript registrierte kann teilnehmen<br>
				private = nur Teams, die vom Ligaadmin freigeschaltet wurden, knnen teilnehmen<br>
				team = wie 'all', mit der Ausnahme, dass der User ber 'Clan anmelden' ein Team fr diese Liga
				erstellt hat<br>
				private-team = der Ligaadmin erstellt beliebige Teamnamen, z.B. die Teamnamen der Bundesliga, und
				teilt dann jedem Team einen User zu".br.br;

		if ( $AnzahlUser == 0) {
#$LSC{UserStatus} == 9 &&		
	
			if (defined $q->param('MJoin')) {
				my $sth = $LSC{MySQL}->do("update lsc_leagues set MJoin=".$LSC{MySQL}->quote($q->param('MJoin'))." where League=$LSC{League}");
				print "Mode Changed.".br.br;
			} else {
				print "Aktuell gewhlter Modus: $LSC{OpenL}{$LSC{LeagueData}{MJoin}}".br;
			}
			print "<b>Memberwahl ndern</b>:".br.br;
				print start_form('post',"admin.pl?League=$LSC{League}&Action=Global");
				print "Modus whlen: ".$q->popup_menu(-name=>'MJoin', -values=>[0,1,2,3], -Labels=>$LSC{OpenL})." ";
				print submit('change'),end_form;
		} else {
			print "Aktuell gewhlter Modus: <b>$LSC{OpenL}{$LSC{LeagueData}{MJoin}}</b>".br;
#			print "Diese Einstellung kann nur von einem GlobalAdmin gendert werden und nur dann, wenn noch kein Team/User der Liga zugeordnet wurde!".br;
			print "Diese Einstellung kann nur gendert werden, wenn noch kein Team/User der Liga zugeordnet wurde!".br;
		}

		print hr;
		print "<div class=Headline>Liganame:</div>".br;
			if ($q->param('LigaName')) {
				my $sth = $LSC{MySQL}->do("update lsc_leagues set Name=".$LSC{MySQL}->quote($q->param('LigaName'))." where League=$LSC{League}");
				print "Name gendert.".br.br;
			} 
			print start_form('post',"admin.pl?League=$LSC{League}&Action=Global");
			print "Name ndern: ".$q->textfield(-name=>'LigaName', -default=>"$LSC{LeagueData}{Name}", -size=>30)." ";
			print submit('change'),end_form;
		print hr;

		print "<div class=Headline>Kategorie:</div>".br;
		print "Kategorie unter der die Liga auf der Startseite aufgelistet wird.".br;

		my %LigaGruppen = ();
		
		my $sthg = $LSC{MySQL}->prepare("select * from lsc_leagues_groups where 1");
		$sthg->execute();
		while (my $gr = $sthg->fetchrow_arrayref()) {
			$LigaGruppen{$gr->[0]} = $gr->[1];
		}
		$sthg->finish;

			if ($q->param('Kategorie') && $LigaGruppen{$q->param('Kategorie')}) {
				my $sth = $LSC{MySQL}->do("update lsc_leagues_group set ID=".$LSC{MySQL}->quote($q->param('Kategorie'))." where League=$LSC{League}");
				print "Kategorie gendert.".br.br;
			} 
			print start_form('post',"admin.pl?League=$LSC{League}&Action=Global");
			print "Kategrorie ndern: ".$q->popup_menu(-name=>'Kategorie', -values=>[sort {$LigaGruppen{$a} cmp $LigaGruppen{$b}} keys %LigaGruppen], -Labels=>\%LigaGruppen)." ";
			print submit('change'),end_form;
		print hr;
		
		print "<div class=Headline>Warteliste:</div>".br;
		print "Wenn unter Members der Modus $LSC{OpenL}{1} gewhlt ist, kann hier eine Warteliste verwaltet werden, in die sich jeder eintragen kann, der an dieser Liga teilnehmen mchte. Der Admin kann dann direkt ber diese Liste User fr die Liga freischalten oder sie aus der Liste lschen.".br;

		if ($LSC{Version} && ($LSC{LeagueData}{MJoin} == 1)) {
				print "<A HREF=\"admin.pl?League=$LSC{League}&Action=Waitlist\">Warteliste verwalten</A>".br;
		} elsif ($LSC{Version} && ($LSC{LeagueData}{MJoin} != 1 && $LSC{LeagueData}{MJoin} != 3)) {
				print "Fr den aktuell gewhlten Modus kann keine Warteliste genutzt werden.".br;
		} else {
			print "Diese Funktion steht nur in der Vollversion zur Verfgung.".br;
		}		
		print hr;


		print "<div class=Headline>Forderungen:</div>".br;
			if (defined $q->param('Forderungen')) {
				if ($q->param('Forderungen') ne "0" && $q->param('Forderungen') ne "1" && $q->param('Forderungen') ne "2") {
					$q->param('Forderungen', 0);
				}
				my @set = ();
				foreach  (qw(Forderungen Forderungen_Zeitraum Forderungen_Change_Min Forderungen_Change_Max Forderungen_ReMoveHours F_Rank_Min F_Rank_Max F_Points_Min F_Points_Max F_Max)) {
					push @set, "$_=".$LSC{MySQL}->quote($q->param($_) || 0);
				}
				my $sth = $LSC{MySQL}->do("update lsc_leagues set ".join(", ", @set)." where League=$LSC{League}");
				print "Forderungsmodus gendert gendert.".br.br;
			} 
			print start_form('post',"admin.pl?League=$LSC{League}&Action=Global");
			print "<table>";
			print "<tr><td>Forderungen: </td><td>".$q->popup_menu(-name=>'Forderungen', -values=>[0,1,2], -Labels=>{0=>"Keine Forderungen erlaubt", 1=>"Forderungen erlauben", 2=>"Forderung vorraussetzen"}, -default=>$LSC{LeagueData}{Forderungen})."</td></tr>";
			print "<tr><td>Wieviele Tage darf im voraus darf gefordert werden: </td><td>".$q->textfield(-name=>'Forderungen_Zeitraum', -default=>"$LSC{LeagueData}{Forderungen_Zeitraum}", -size=>5)."</td></tr>";
			print "<tr><td>Wieviele Tage darf eine Forderung nach vorne verlegt werden: </td><td>".$q->textfield(-name=>'Forderungen_Change_Min', -default=>"$LSC{LeagueData}{Forderungen_Change_Min}", -size=>5)."</td></tr>";
			print "<tr><td>Wieviele Tage darf eine Forderung nach hinten verschoben werden: </td><td>".$q->textfield(-name=>'Forderungen_Change_Max', -default=>"$LSC{LeagueData}{Forderungen_Change_Max}", -size=>5)."</td></tr>";
			print "<tr><td>Bis wieviel Stunden vor dem besttigten Forderungsdatum darf ein Match abgebrochen werden (0=abbrechen nicht erlaubt): </td><td>".$q->textfield(-name=>'Forderungen_ReMoveHours', -default=>"$LSC{LeagueData}{Forderungen_ReMoveHours}", -size=>5)."</td></tr>";
			print "<tr><td>Wer darf gefordert werden?<br>Hier knnen weitere Beschrnkungen fr Forderungen festgelegt werden:</td><td></td></tr>";
			print "<tr><td>User drfen X Pltze nach unten/oben fordern: (Keine Beschrnkung, wenn beide Werte auf 0)</td><td>".$q->textfield(-name=>'F_Rank_Min', -default=>"$LSC{LeagueData}{F_Rank_Min}", -size=>5).$q->textfield(-name=>'F_Rank_Max', -default=>"$LSC{LeagueData}{F_Rank_Max}", -size=>5)."</td></tr>";
			print "<tr><td>User drfen X Punkte nach unten/oben fordern: (Keine Beschrnkung, wenn beide Werte auf 0)</td><td>".$q->textfield(-name=>'F_Points_Min', -default=>"$LSC{LeagueData}{F_Points_Min}", -size=>5).$q->textfield(-name=>'F_Points_Max', -default=>"$LSC{LeagueData}{F_Points_Max}", -size=>5)."</td></tr>";
			print "<tr><td>Maximale anzahl an offenen Forderungen (0=keine Beschrnkung)</td><td>".$q->textfield(-name=>'F_Max', -default=>"$LSC{LeagueData}{F_Max}", -size=>5)."</td></tr>";
			print "</table>";

			     

			print submit('change'),end_form;
			print "Keine Forderungen erlaubt = Teams knnen nicht gefordert werden, Ergebnisse knnen nur direkt eingetragen werden".br;
			print "Forderungen erlauben = Teams knnnn gefordert werden, Ergebnisse knnen aber auch direkt eingetragen werden".br;
			print "Forderung vorraussetzen = Ergebnisse knnen nur nach besttigten Forderungen eingetragen werden".br;
		print hr;










		# punkte
		my @pkeys = qw(Won1 Won2 Lost1 Lost2 Draw1 Draw2 Draws ForceDraws StartPoints);
		my @bkeys = qw(WonDiff1 WonDiff2 LostDiff TopPos TopBonus WonRangFaktor LostRangFaktor);
		if ($q->param('Punkte speichern')) {
			my $ok = 1;
			my @Felder;
			my @Values;
			foreach my $F (@pkeys) {
				if (!($q->param($F)=~/[^0-9\-]/)) {
					#push (@Felder, $F);
					#push (@Values, $LSC{MySQL}->quote($q->param($F) || 0));
					push (@Values, "$F=".$LSC{MySQL}->quote($q->param($F) || 0));
				} else {
					$ok=0;
				}
			}
			if ($ok) {
				#push (@Felder, 'League');
				#push (@Values, $LSC{MySQL}->quote($LSC{League}));
				#my $do	= "update lsc_leagues_points (".join(', ', @Felder).") Values (".join(', ',	@Values).") where League=$LSC{League}";
				my $do	= "update lsc_leagues_points set ".join(', ',	@Values)." where League=$LSC{League}";
				my $sth = $LSC{MySQL}->do("$do");
				print "<b>Neue Punkte wurden gespeichert.</b>".hr;
			} else {
				print "<b>Werte konnten nicht gespeichert werden, da unerlaubte Zeichen enthalten waren!</b>".br;
			}
		}
		if ($q->param("ELO-Punkte speichern")) {
			if ($q->param("Elo1")=~/[^0-9]/ || $q->param("Elo2")=~/[^0-9]/) {
				print "<b>Werte konnten nicht gespeichert werden, da unerlaubte Zeichen enthalten waren!</b>".br;
			} else {
				my $do	= "update lsc_leagues_points set Elo1=".
					$LSC{MySQL}->quote($q->param("Elo1")).", Elo2=".
					$LSC{MySQL}->quote($q->param("Elo2"))." where League=$LSC{League}";
				my $sth = $LSC{MySQL}->do("$do");
				print "<b>Elo-Werte wurden gespeichert.</b>".hr;
			}
		
		
		}
		if ($q->param('Bonuspunkte speichern')) {
			my $ok = 1;
			my @Felder;
			my @Values;
			foreach my $F (@bkeys) {
				if (!($q->param($F)=~/[^0-9\-]/)) {
					push (@Felder, $F);
					push (@Values, $LSC{MySQL}->quote($q->param($F)));
				} else {
					$ok=0;
				}
			}
			if ($ok) {
				push (@Felder, 'League');
				push (@Values, $LSC{MySQL}->quote($LSC{League}));
				my $do	= "replace into lsc_leagues_points_bonus (".join(', ', @Felder).") Values (".join(', ',
				@Values).")";
				my $sth = $LSC{MySQL}->do("$do");
				print "<b>Neue Bonuspunkte wurden gespeichert.</b>".hr;
			} else {
				print "<b>Werte konnten nicht gespeichert werden, da unerlaubte Zeichen enthalten waren!</b>".br;
			}
		}
		print start_form('post',"$scriptname?League=$LSC{League}&Action=Global");
		
		my $select	= "select * from lsc_leagues_points where League=$LSC{League}";
		my $sth = $LSC{MySQL}->prepare("$select");
		$sth->execute();
		my $ref = $sth->fetchrow_hashref();
		$sth->finish;
		print "<table cellspacing=0><tr>";
		foreach (@pkeys) {		print "<td class=Headline width=50>$_</td>";	}
		print "</tr>";
		print "<tr>";
		foreach (@pkeys) {		
			print "<td align=center>".$q->textfield(-name=>$_, -size=>3, -default=>$ref->{$_})."</td>";	
		}
		print "</tr>";
		#beispiele
		print "<tr><td align=center>".join("</td><td align=center>",(3,0,0,0,1,1,1,0,0,'Fussball'))."</td></tr>";	
		print "<tr><td align=center>".join("</td><td align=center>",(2,2,0,1,1,1,1,0,0,'NHL'))."</td></tr>";	
		print "</table>";
		print submit('Punkte speichern'),end_form;
		print "<table cellspacing=0>";
		print "<tr><td class=Headline width=60>Won1</td><td></td><td>Punkte bei einem Sieg</td></tr>";
		print "<tr><td class=Headline>Won2</td><td></td><td>Punkte bei einem Sieg in der Verlngerung</td></tr>";
		print "<tr><td class=Headline>Lost1</td><td></td><td>Punkte bei einer Niederlage</td></tr>";
		print "<tr><td class=Headline>Lost2</td><td></td><td>Punkte bei einer Niederlage in der Verlngerung</td></tr>";
		print "<tr><td class=Headline>Draw1</td><td></td><td>Punkte bei einem Unentschieden</td></tr>";
		print "<tr><td class=Headline>Draw2</td><td></td><td>Punkte bei einem Unentschieden nach der Verlngerung</td></tr>";
		print "<tr><td class=Headline>Draws</td><td></td><td>sind unentschieden erlaubt? 0=Nein, 1=Ja</td></tr>";
		print "<tr><td class=Headline>ForceDraws</td><td></td><td>Bei unentschieden wird das
		Ergebnisformular solange fr weitere Ergebnisse ausgegeben, bis ein Ergebnis eingetragen wird,
		das nicht unentschieden lautet. Bitte Draws auf 0 stellen.</td></tr>";
		print "<tr><td class=Headline>StartPoints</td><td></td><td>Startpunkte, die jedes Team erhlt, z.b. bei Elo=1000</td></tr>";
		print "</table>";
		print br.br;
		print "Punkte fr das ELO-System festlegen: ".br;
		$select	= "select Elo1, Elo2 from lsc_leagues_points where League=$LSC{League}";
		$sth = $LSC{MySQL}->prepare("$select");
		$sth->execute();
		$ref = $sth->fetchrow_arrayref();
		$sth->finish;

		print start_form('post',"$scriptname?League=$LSC{League}&Action=Global");
		print "Wert 1:".$q->textfield(-name=>"Elo1", -size=>5, -default=>$ref->[0]).br;	
		print "Wert 2:".$q->textfield(-name=>"Elo2", -size=>5, -default=>$ref->[1]).br.br;	
		print "ACHTUNG: Wenn Werte frs das Elosystem eingetragen wurden, dann werden die Punkte fr
		\"Won1, Won2, Lost1, Lost2, Draw1, Draw2\" von oben ignoriert!".br.br;
		print "Ich kann zur Zeit keine Dokumentation zum ELO-System zur Verfgung stellen. Google
		sollte aber relativ schnell Hilfe bringen ;-) wenn Du dieses Punkte-System nutzen willst.".br;
		print submit('ELO-Punkte speichern'),end_form;
		
		
		print hr;
		
		# Bonus Punkte
		print start_form('post',"$scriptname?League=$LSC{League}&Action=Global");
		
		$select	= "select * from lsc_leagues_points_bonus where League=$LSC{League}";
		$sth = $LSC{MySQL}->prepare("$select");
		$sth->execute();
		$ref = $sth->fetchrow_hashref();
		$sth->finish;
		print "<table cellspacing=0>";
		print "<tr><td class=Headline width=60>WonDiff1</td><td>".$q->textfield(-name=>"WonDiff1", -size=>3, -default=>$ref->{"WonDiff1"})."</td><td>ab dieser Punkte-/Tordifferez bekommt der Sieger einen ExtraPunkt (siehe RankingLigen auf leagues.ihoax.de)</td></tr>";
		print "<tr><td class=Headline>WonDiff2</td><td>".$q->textfield(-name=>"WonDiff2", -size=>3, -default=>$ref->{"WonDiff2"})."</td><td>wie oben</td></tr>";
		print "<tr><td class=Headline>LostDiff</td><td>".$q->textfield(-name=>"LostDiff", -size=>3, -default=>$ref->{"LostDiff"})."</td><td>bis zu dieser Punkte-/Tordifferez bekommt der Verlierer einen Extrapunkt</td></tr>";
		print "<tr><td class=Headline>TopPos</td><td>".$q->textfield(-name=>"TopPos", -size=>3, -default=>$ref->{"TopPos"})."</td><td>Der Sieger erhlt einen die Punke unter TopBonus als Extrapunkte, falls er gegen jemanden gewonnen hat, der oberhalb der 'TopPos' in der Tabelle steht und der Sieger selbst unterhalb dieser Position in der Tabelle steht</td></tr>";
		print "<tr><td class=Headline>TopBonus</td><td>".$q->textfield(-name=>"TopBonus", -size=>3, -default=>$ref->{"TopBonus"})."</td><td>siehe TopPos</td></tr>";
		print "<tr><td class=Headline>WonRangFaktor</td><td>".$q->textfield(-name=>"WonRangFaktor", -size=>3, -default=>$ref->{"WonRangFaktor"})."</td><td>Erklrung folgt</td></tr>";
		print "<tr><td class=Headline>LostRangFaktor</td><td>".$q->textfield(-name=>"LostRangFaktor", -size=>3, -default=>$ref->{"LostRangFaktor"})."</td><td>siehe WonRangFaktor</td></tr>";
		print "</table>";
		print submit('Bonuspunkte speichern'),end_form;
		print hr;
		#Ergebnisformular
		print "<div class=Headline>Wahl der Ergebniseingabe</div>".br;
		my @ekeys = qw(Team-Punkte Team-Punkte-Map Team-Sieg-Unentschieden-Map Team-Sieg Team-Sieg-Unentschieden
		OverTime Location POG);
		if ($q->param("Ergebniseingabe speichern")) {
			my $ok = 1;
			my @Felder;
			my @Values;
			for (my $i=0; $i<=4; $i++) {
				my $wert = 0;
				if ($q->param('Formular') eq $ekeys[$i]) {
					$wert=1;
				}
				push (@Felder, "`$ekeys[$i]`");
				push (@Values, $wert);
			}
			for (my $i=5; $i<=7; $i++) {
				my $wert = 0;
				if ($q->param($ekeys[$i]) eq 'ja') {
					$wert=1;
				}
				push (@Felder, "`$ekeys[$i]`");
				push (@Values, $wert);
			}
			push (@Felder, 'League');
			push (@Values, $LSC{MySQL}->quote($LSC{League}));
				
			my $sth = $LSC{MySQL}->do("replace into lsc_leagues_newgame (".join(', ', @Felder).") Values (".join(', ',
			@Values).")");
			print "<b>Werte wurden gespeichert</b>".br;
		}
		$select	= "select * from lsc_leagues_newgame where League=$LSC{League}";
		$sth = $LSC{MySQL}->prepare("$select");
		$sth->execute();
		my $newgame = $sth->fetchrow_hashref();
		$sth->finish;
		print "<b>Aktuell gewhlte Einstellungen:</b>".br;

		print "<b>Ergebnisformular: </b>";
		for (my $i=0; $i<=4; $i++) {
			print $newgame->{$ekeys[$i]} ? $ekeys[$i] : "";
		}
			$q->param("Teamname1", "Team1");
			$q->param("Teamname2", "Team2");
			Require("LSCErgebnisse2.pm");
			_Ergebnisse_Formular();
		print br;
		print "<b>Weitere Einstellungen:</b>".br;
		for (my $i=5; $i<=7; $i++) {
			print $newgame->{$ekeys[$i]} ? $ekeys[$i].br : "";
			
		}
		print hr;
		print "<b>Einstellungen neu festlegen</b>:".br;
		print start_form('post',"$scriptname?League=$LSC{League}&Action=Global");
		print "Formular: ".br.$q->popup_menu(-name=>"Formular", -values=>[@ekeys[0..4]]).br;
		print "Verlngerung/Overtime: ".$q->popup_menu(-name=>"OverTime", -values=>['nein','ja']).br;
		print "Heim-/Auswrtspielwahl: ".$q->popup_menu(-name=>"Location", -values=>['nein','ja']).br;
		print "Player of the game: ".$q->popup_menu(-name=>"POG", -values=>['nein','ja']).br;
		print submit('Ergebniseingabe speichern'),end_form;


	} elsif ($LSC{UserStatus} == 9) {
		#neue Liga Erstellen
		if ($q->param('Liga erstellen')) {
			my @Values;
			my @Felder;
			#League 
			foreach my $F (qw(Name MJoin Layout Spielplan AnzahlSpiele Playoff)) {
				push (@Felder, $F);
				push (@Values, $LSC{MySQL}->quote($q->param($F)|| ""));
			}
			push (@Felder, 'Status');
			push (@Values, $LSC{MySQL}->quote(2));

			my $sth;
			$sth = $LSC{MySQL}->prepare("insert into lsc_leagues (".join(', ', @Felder).") Values
					(".join(', ', @Values).")");
			$sth->execute();
			my $ID = $sth->{mysql_insertid};
			$sth->finish;
			
			#Kategorie:
			my $GroupID = $q->param('Group') || 0;
			if ($q->param('NewGroup')) {
				my $sth;
				$sth = $LSC{MySQL}->prepare("insert into lsc_leagues_groups (Name) Values
						(".$LSC{MySQL}->quote($q->param('NewGroup')).")");
				$sth->execute();
				$GroupID = $sth->{mysql_insertid};
				$sth->finish;
			}
			my $DO = "insert into lsc_leagues_group (League, ID) Values	(".$LSC{MySQL}->quote($ID).", $GroupID)";
			$sth = $LSC{MySQL}->do($DO);
			$sth = $LSC{MySQL}->do("insert into lsc_leagues_points (League) Values (".$LSC{MySQL}->quote($ID).")");
			
			print "<b>Liga wurde erstellt! ID: $ID</b>".br;
			if ($q->param("Admin")) {
					my $do = "replace lsc_leagues_admins (League, User) 
						Values (?, ?)";
						my $sth = $LSC{MySQL}->prepare($do);
					$sth->execute($ID, $q->param("Admin"));
					$sth->finish;
					print "Admin wurde hinzugefgt.".br;
			}
		}

		#Gruppen laden:
		my %LigaGruppen = ();
		
		my $sthg = $LSC{MySQL}->prepare("select * from lsc_leagues_groups where 1");
		$sthg->execute();
		while (my $gr = $sthg->fetchrow_arrayref()) {
			$LigaGruppen{$gr->[0]} = $gr->[1];
		}
		$sthg->finish;
		
		print start_form('post',"$scriptname?League=$LSC{League}&Action=Global");
		print "<table><tr><td>Nummer</td><td>Name</td></tr>";
		print "<tr>";
		print "<td>wird automatisch vergeben</td>";
		print "<td>".$q->textfield(-name=>'Name', -size=>20)."</td></tr>\n";
		print "<tr><td>Kategorie</td><td>neue Kategorie</td></tr>".
			"<tr><td>".$q->popup_menu(-name=>'Group', -values=>[sort {$LigaGruppen{$a} cmp $LigaGruppen{$b}} keys
			%LigaGruppen], -Labels=>\%LigaGruppen)."</td>".
			"<td>".$q->textfield(-name=>'NewGroup', -size=>30)."</td>".
			"</tr>\n";
		print "<tr><td>AdminID</td>".
			"<td>".$q->textfield(-name=>'Admin', -size=>10)."</td>".
			"</tr>\n";
		print "</table>";
		print "<table><tr><td>Members</td></tr>";
		print "<tr>".
			"<td>".$q->popup_menu(-name=>'MJoin', -values=>[0,1,3], -Labels=>$LSC{OpenL})."</td>".
			"<td>".($LSC{LayoutExtern} ? "Layout: ".$q->popup_menu(-name=>'Layout', -values=>[0,1,2], -Labels=>{0 => 'standard', 1=>'ffentlich(Text)', 
			2=>'ffentlich(Button)'}) : "")."</td>".
			"</tr>\n";
		print "</table>";
		print submit('Liga erstellen'),end_form;
		print "<table>";
		print "<tr>".
			"<td>Name</td>".
			"<td>maximal 20 Zeichen</td>".
			"</tr>\n";
		print "<tr>".
			"<td>Members</td>".
			"<td>all = Jeder im Ligascript registrierte kann teilnehmen<br>
				private = nur Teams, die vom Ligaadmin freigeschaltet wurden, knnen teilnehmen<br>
				team = wie 'all', mit der Ausnahme, dass der User ber 'Clan anmelden' ein Team fr diese Liga
				erstellt hat<br>
				private-team = der Ligaadmin erstellt beliebige Teamnamen, z.B. die Teamnamen der Bundesliga, und
				teilt dann jedem Team einen User zu
				</td>".
			"</tr>\n";
		print "</table>";

		
	} else { 
		print "Diese Funktion ist hier nicht verfgbar!";
	}
	
}
sub AdminTeamVerwarnen {
	print "Hier kannst Du ein Clan/Team verwarnen, dazu einfach ein Team auswhlen und die Verwarnung im
	Textfeld eintragen. Das verwarnte Team wird per Email darber benachrichtigt, ausserdem wird in den
	Informationen zu dem Team die angebene Nachricht und neben dem Teamnamen wird eine Gelbekarte
	angezeigt werden.".br;

	if ($q->param('Verwarnung speichern') && !($q->param('Team')=~/[^0-9]/)) {
		my $text=$q->param('Text');
		$text = $LSC{MySQL}->quote($text);
		my $team = $LSC{MySQL}->quote($q->param('Team'));
		my $DO = "insert into lsc_teams_gelb (League, Team, Text) Values".
			"($LSC{League}, $team, $text)";
			print hr;
		my $sth = $LSC{MySQL}->do($DO);
		print "<b>Verwarnung wurde gespeichert.</b>".br;
	}
	if ($q->param('Verwarnung loeschen') && !($q->param('Team')=~/[^0-9]/)) {
		my $team = $LSC{MySQL}->quote($q->param('Team'));
		my $DO = "delete from lsc_teams_gelb where League=$LSC{League} and Team=$team";
		my $sth = $LSC{MySQL}->do($DO);
		print "<b>Verwarnung wurde gelscht.</b>".br;
	}
	
	print start_form('post',"$scriptname?League=$LSC{League}&Action=TeamVerwarnen");
	my %Members = Members();
	print "Team: ".br;
	print $q->popup_menu(-name=>'Team', -values=>[sort {"\L$Members{$a}" cmp
			"\L$Members{$b}" } keys %Members], -Labels=>\%Members), "   ";
	print br;
	print "Verwarnung: ".br;
	print $q->textarea('Text',"",10,30);
	print br;
	print submit('Verwarnung speichern'),end_form;

	
	print start_form('post',"$scriptname?League=$LSC{League}&Action=TeamVerwarnen");
	print "Team: ".br;
	print $q->popup_menu(-name=>'Team', -values=>[sort {"\L$Members{$a}" cmp
			"\L$Members{$b}" } keys %Members], -Labels=>\%Members), "   ";
	print submit('Verwarnung loeschen'),end_form;
	
}
sub AdminUserVerwarnen {
	print "Hier kannst Du einen User eines Clan/Team verwarnen, dazu einfach ein Team und anschlieend den
	User des Teams auswhlen und die Verwarnung im
	Textfeld eintragen. Das verwarnte Team wird per Email darber benachrichtigt, ausserdem wird in den
	Informationen zu dem Team die angebene Nachricht und neben dem Teamnamen wird eine Gelbekarte
	angezeigt werden.".br;

	if ($q->param('Verwarnung speichern') && !($q->param('User')=~/[^0-9]/)) {
		my $text=$q->param('Text');
		$text = $LSC{MySQL}->quote($text);
		my $user = $LSC{MySQL}->quote($q->param('User'));
		my $DO = "insert into lsc_user_gelb (League, User, Text) Values".
			"($LSC{League}, $user, $text)";
			print $DO;
			print hr;
		my $sth = $LSC{MySQL}->do($DO);
		print "<b>Verwarnung wurde gespeichert.</b>".br;
	}
	if ($q->param('Verwarnung loeschen') && !($q->param('User')=~/[^0-9]/)) {
		my $user = $LSC{MySQL}->quote($q->param('User'));
		my $DO = "delete from lsc_user_gelb where League=$LSC{League} and User=$user";
		my $sth = $LSC{MySQL}->do($DO);
		print "<b>Verwarnung wurde gelscht.</b>".br;
	}
	if ($q->param('Team waehlen') && !($q->param('Team')=~/[^0-9]/)) {
		print start_form('post',"$scriptname?League=$LSC{League}&Action=UserVerwarnen");
		my $TeamMembers = TeamMembersEasy($q->param('Team'));
		if (keys %$TeamMembers) {
			print $q->popup_menu(-name=>'User', -values=>[sort {"\L$TeamMembers->{$a}" cmp
				"\L$TeamMembers->{$b}" } keys %{$TeamMembers}], -Labels=>$TeamMembers), "   ";
			print br;
			print "Verwarnung: ".br;
			print $q->textarea('Text',"",10,30);
			print br;
			print submit('Verwarnung speichern'),end_form;

			print start_form('post',"$scriptname?League=$LSC{League}&Action=UserVerwarnen");
			print "Team: ".br;
			print $q->popup_menu(-name=>'User', -values=>[sort {"\L$TeamMembers->{$a}" cmp
				"\L$TeamMembers->{$b}" } keys %{$TeamMembers}], -Labels=>$TeamMembers), "   ";
			print submit('Verwarnung loeschen'),end_form;
		}else {
			print "Keine Member gefunden!".br;
		}

	}
	


	print start_form('post',"$scriptname?League=$LSC{League}&Action=UserVerwarnen");
	my %Members = Members();
	print "Team whlen: ".br;
	print $q->popup_menu(-name=>'Team', -values=>[sort {"\L$Members{$a}" cmp
			"\L$Members{$b}" } keys %Members], -Labels=>\%Members), "   ";
	print submit('Team waehlen'),end_form;
}

sub AdminUserVerwalten {
	unless ($LSC{UserStatus} == 9) {
		return;
	}
	
my %UserStatus = (
	0, 'Account not unlocked',
	1, 'Normal',
	2, 'Locked by Admin',
	3, 'InActiv',
	9, 'GlobalAdmin',
);
	print "Bitte beachte beim lschen, dass bei Usern, die bereits Spiele eingetragen haben, 
		bestimmte Teamdaten erhalten bleiben, damit Tabellen und Ergebnislisten durch das
		lschen der Userdaten, nicht verndert werden.".br.br;
		
	print "<a href=$scriptname?League=$LSC{League}&Action=User>Userverwaltung - Hauptmenue</a>".hr;
	if ((my $id=TeamSuchen('admin.pl', 'User', 2))) {	
		print "<div class=Headline>User Verwalten:</div>";
		my ($select,$from,$where,$group,$order);
		$select	= "*";
		$from	= "lsc_user";
		$where	= "UserID=$id";
		$group	= "";
		$order	= "";

		my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
		$sth->execute();
		my $ref = $sth->fetchrow_hashref();
		$sth->finish;
		if ($ref) {
			print start_form('post',"$scriptname?League=$LSC{League}&Action=User");
			foreach my $f (qw(Login Firstname Lastname Email ICQ)) {
				print "$f: => ";
				print $q->textfield(-name=>$f, -size=>30, -default=>$ref->{$f}).br.br;
			}
			print "Status: => ";
			if ($ref->{'Status'} == 0) {
				print "Account wurde noch nicht freigeschaltet => ".
				submit('freischalten').br;
			} else {
				print $q->popup_menu(-name=>'Status', -values=>[1,2,3,9], 
							-Labels=>\%UserStatus,
							-default=>"$ref->{'Status'}").br.br;
			}
			print "Useraktiv: ".(UserAktiv($ref->{'UserID'})?'ja':'nein').br;
			
			print "Neues Passwort festlegen: => ";
			print $q->textfield(-name=>'Password', -size=>30).br.br;
			print $q->hidden('UserID', $ref->{'UserID'});
			print submit('speichern'),end_form.br.br;

			print start_form('post',"$scriptname?League=$LSC{League}&Action=User");
			print "Um diesen User zu lschen <b>LOESCHE-$ref->{'UserID'}</b> eingeben: ";
			print $q->textfield(-name=>'text', -size=>30).br.br;
			print $q->hidden('UserID', $ref->{'UserID'});
			print submit('loeschen'),end_form;
			
		} else {
			print "User Daten konnten nicht geladen werden:";
		}
	} elsif ($q->param('speichern')) {
		my @feld;
		unless ($q->param('UserID')) {
			print "angaben unvollstndig";
			return;
		}
		#ICQ Status
		foreach my $f (qw(Login Firstname Lastname Email Status)) {
			unless ($q->param($f)) {
				print "angaben unvollstndig";
				return;
			}
		
			push (@feld, "$f=".$LSC{MySQL}->quote($q->param($f)));
		}
		
		if ($q->param('Password')) {
			push (@feld, 'Password='.$LSC{MySQL}->quote(crypt($q->param('Password'), $LSC{cryptpass})));
		}
		my $sth = $LSC{MySQL}->do("update lsc_user set ".join(',',@feld).
				" where UserID=".$LSC{MySQL}->quote($q->param('UserID')));
		print "gespeichert";
	} elsif ($q->param('loeschen')) {
		my @feld;
		unless ($q->param('UserID')) {
			print "Angaben unvollstndig (keine UserID bertragen)";
			return;
		}
		if ($q->param('UserID')=~/[^0-9]/) {
			print "Angaben unvollstndig2 (UserID enthkt unelaubte Zeichen)";
			return;
		}
		if ($q->param('text') ne 'LOESCHE-'.$q->param('UserID')) {
			print "angaben unvollstndig3";
			return;
		}		

		Require("LSCuser.create.pm");
		UserLoeschen($q->param('UserID'));
	} elsif ($q->param('freischalten')) {
		unless ($q->param('UserID')) {
			print "angaben unvollstndig1";
			return;
		}
		if ($q->param('UserID')=~/[^0-9]/) {
			print "angaben unvollstndig2";
			return;
		}
		my $user = UserKontaktDatenFromUserID($q->param('UserID'));
		if ($user) {
			Require("LSCuser.create.pm");
			UserAcountFreischalten($user->{Login}, $q->param('UserID'));
			print "Dein Account ist freigeschaltet.".br;
		} else {
			print "angaben unvollstndig3";
		}
	}

}
sub AdminTeamVerwalten {
	unless ($LSC{UserStatus} == 9) {
		return;
	}
	
	print "Teamsverwalten:".br;
	print "Bitte beachte beim lschen, dass bei Teams, fr die bereits Spiele eingetragen wurden, 
		bestimmte Teamdaten erhalten bleiben, damit Tabellen und Ergebnislisten durch das
		lschen der Daten, nicht verndert werden.".br.br;
		
	print "<a href=$scriptname?League=$LSC{League}&Action=Team>Teamverwaltung - Hauptmenue</a>".hr;

	if ((my $id=TeamSuchen('admin.pl', 'Team', 1))) {	
		print start_form('post',"$scriptname?League=$LSC{League}&Action=Team");
		print "Um dieses Team zu lschen <B>LOESCHE-$id</B> eingeben: ";
		print $q->textfield(-name=>'text', -size=>30).br.br;
		print $q->hidden('TeamID', $id);
		print submit('loeschen'),end_form;
	
		Require("LSCuser.modif.pm");
		TeamInfoBearbeiten('', $id);
	} elsif ($q->param('loeschen')) {
		my @feld;
		unless ($q->param('TeamID')) {
			print "Angaben unvollstndig(1)";
			return;
		}
		if ($q->param('TeamID')=~/[^0-9]/) {
			print "Angaben unvollstndig(2)";
			return;
		}
		if ($q->param('text') ne 'LOESCHE-'.$q->param('TeamID')) {
			print "Angaben unvollstndi(3)";
			return;
		}		

		Require("LSCuser.create.pm");
		TeamLoeschen($q->param('TeamID'));
	}	
}
sub AdminTeamVerwalten2 {
	unless ($LSC{UserStatus} == 9) {
		return;
	}
	print "<a href=$scriptname?League=$LSC{League}&Action=Team>Teamverwaltung - Hauptmenue</a>".hr;
	Require("LSCuser.modif.pm");
	TeamInfoBearbeiten(@_);
}

sub AdminListTeams {
	unless ($LSC{UserStatus} == 9) {
		#return;
	}
	my $sth = $LSC{MySQL}->prepare("SELECT ID FROM lsc_teams WHERE First=0");
	$sth->execute();
	my %First;
	while (my $ref = $sth->fetchrow_arrayref()) {
		$First{$ref->[0]} = 1;
	}
	$sth->finish;
	
	print "<table>";
		print "<tr>";		
		print "<td>ID</td>";
		print "<td>Name</td>";
		print "<td>Ligen+Verwarnungen</td>";
		print "<td>Members</td>";
		print "<tr>";		
	$sth = $LSC{MySQL}->prepare("SELECT ID, Name, Status FROM lsc_teams WHERE First=0 order by ID");
	$sth->execute();
	my $League = $LSC{League};
	while (my $ref = $sth->fetchrow_arrayref()) {
		$LSC{League} = $League;
#		unless ($First{$ref->[0]}) {
			print "<tr>";		
				print "<td>$ref->[0]</td>";
				print "<td>".TeamLink($ref->[1],$ref->[0])."</td>";
				my %Ligen = AlleLigenInDenenTeamSpielt($ref->[0]);
				print "<td>";
				my $x = 0;	
					foreach (keys %Ligen) {
						if ($x) {print "<br>"};
						$x=1;
						$LSC{League} = $Ligen{$_};
						print "$Ligen{$_}:";
						if(TeamVerwarnt($ref->[0])) {
							print TeamLink($_,$ref->[0],'',1);
						} else {
							print "$_";
						}
					}
				print "</td>";
				print "<td align=right>";
				my $TeamMembers = TeamMembers($ref->[0]);
					print "".(keys %{$TeamMembers})/1;
				print "</td>";
				


			print "</tr>";		
	#	}
	}
	$LSC{League} = $League;
	$sth->finish;
	print "</table>";

}

sub PageStats {
	if ($LSC{UserStatus} == 9) {
		Counter_ShowHistory();
	} else {
		print "unbekannte Funktion".br;
	}
}

