
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################



Require("LSCAdminFull.pm");

# AddTeams
 

sub AddTeams {
	print "Hier kannst Du Teams bzw. User fr deine Liga freischalten.".br;
	if (Liga_AnzahlSpiele($LSC{League}) && $LSC{LeagueData}{Spielplan}) {
		print "Fr diese Liga wurde der Spielplanmodus gewhlt!".br.
			"Da bereits Spiele eingetragen wurden, muss der Spielplan nun manipuliert werden, um dieses Team in den Spielplan aufzunehmen!".br;
		#return;
	}
	my $id;
	if (($id=TeamSuchen('admin.pl', 'AddTeams'))) {
		Require("LSCuser.create.pm");
		_JoinLeagueTeam($id);
		print "Das Team ist nun fr diese Liga freigeschaltet!".br;
	}
	
	### mehrere Teams auf einmal freischalten
	print hr;
	print "<b>mehrere Teams gleichzeitig freischalten:</b>".br;
	if ($_[0] eq 'PlusAdd' && $q->param('TeamIDs')) {
		foreach my $T (split(/\n/,$q->param('TeamIDs'))) {
			chomp($T);
			chop($T) if $T=~/\r/;
			print " - #$T ";
			if (!($T=~/[^0-9]/) && $T && Teamvorhanden($T)) {
				Require("LSCuser.create.pm");
				_JoinLeagueTeam($T);
				print "hinzugefgt.".br;
			} else {
				print "unbekannte TeamID.".br;
			}
		}
		print hr;
	}
	if ($q->param('delete')) {
		Require("LSCuser.create.pm");
		_LeaveLeagueTeam($q->param('Team'));
		print "Team ausgetragen.".br;
		print hr;
	}
		
	print "Wenn Dir die TeamID's bekannt sind, dann kannst du hier einfach eine Liste der TeamID's einfgen, die freigeschaltet werden sollen.".br;
	print "Pro Zeil nur eine ID!".br;
	print start_form('post',"$scriptname?League=$LSC{League}&Action=AddTeams&Action2=PlusAdd");
	print "TeamID's:", br, $q->textarea('TeamIDs',"",10,5);
	print submit('add'),end_form;
	print br.br.br;
	
	print "Team aus Liga lschen:".br;
	print "- ACHTUNG!!! Wenn Teams nach dem Ligastart gelscht werden, 
			dann werden nicht die eingetragenen Ergebnisse gelscht! 
			Lediglich das Team wird aus der Liga entfernt, kann nicht mehr am Spielbetrieb teilnehmen 
			und taucht in der Tabelle nicht mehr auf. Ergebnisse andere Teams gegen dieses Team bleiben
			erhalten!".br;
	print "Um ein Team komplett inklusiv Ergebnisse zu lschen, bitte erst unter \"Ergebnisse\" die Ergebnisse des Teams lschen.".br;
	my %Members = Members();
	print start_form('post',"$scriptname?League=$LSC{League}&Action=AddTeams");
	print $q->popup_menu(-name=>'Team', -values=>[sort {"\L$Members{$a}" cmp
			"\L$Members{$b}" } keys %Members], -Labels=>\%Members), "   ";
	print submit('delete'),end_form;	

	print br;
	if ($q->param('inaktiv')) {
		Require("LSCuser.modif.pm");
		TeamLigaStatusSpeichern($q->param('Team'), $LSC{League}, 1);
		print "Team auf inaktiv gesetzt!";
		print hr;
	}
	print "Team auf inaktiv setzen:".br;
	print start_form('post',"$scriptname?League=$LSC{League}&Action=AddTeams");
	print $q->popup_menu(-name=>'Team', -values=>[sort {"\L$Members{$a}" cmp
			"\L$Members{$b}" } keys %Members], -Labels=>\%Members), "   ";
	print submit('inaktiv'),end_form;	

	print br;
	if ($q->param('aktiv')) {
		Require("LSCuser.modif.pm");
		TeamLigaStatusSpeichern($q->param('Team'), $LSC{League}, 0);
		print "Team auf aktiv gesetzt!";
		print hr;
	}
	print "Team auf aktiv setzen:".br;
	print start_form('post',"$scriptname?League=$LSC{League}&Action=AddTeams");
	print $q->popup_menu(-name=>'Team', -values=>[sort {"\L$Members{$a}" cmp
			"\L$Members{$b}" } keys %Members], -Labels=>\%Members), "   ";
	print submit('aktiv'),end_form;	
}

sub AdminTabelle {
		# Tabelle
		if ($LSC{UserStatus} == 9) {
			print "<div class=Headline>Tabelle Konfiguration</div>".br;
			if ($q->param('Modus')) {
					my $sth = $LSC{MySQL}->do("update lsc_leagues set TableCreat=".$LSC{MySQL}->quote($q->param('Modus') || 2)." where League=".$LSC{League});
					print "Modus gespeichert.".br.br;
			}
			print start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}");
			print $q->popup_menu(-name=>'Modus', -values=>[1,2,3], -Labels=>{1=>"Modus 1",2=>"Modus 2 (standard)",3=>"Modus 3"}, -default=>$LSC{LeagueData}->{TableCreat}), "   ";
			print submit('change'),end_form;	
			print "<table><tr><td width=100>Modus 1 </td><td>Tabellen aus LSCPoints erstellen und sortieren</td></tr>
					<tr><td>Modus 2 </td><td>Tabelle aus gespeicherter Platzierung erstellen</td></tr>
					<tr><td>Modus 3 </td><td>Tabelle aus gespeicherter Platzierung erstellen, Platzierungen werden
					ber ein externes Script alle X Minuten aktualisiert</td></tr></table>".br;
			print "Ein Modus ab 2 ist notwendig, wenn die speziellen Forderungsfunktionen genutzt werden sollen oder das Elo Punktesystem genutzt werden soll!".br;
			print "Modus 3 funktioniert nur, wenn das Update Script extern, z.b. per Cron Job regelmssig aufgerufen wird.".br;
			print br.br.br;
		}
		if ($LSC{LeagueData}->{TableCreat} >= 2) {
			print "<div class=Headline>Tabelle Update</div>".br;
			if ($q->param('Update-Tabelle')) {
				Require("LSCTabelle2.pm");
				Tabelle2Simpel($LSC{League}, 0, 1); #1 fr update
				print "Tabelle wurde neu initialisiert.".br;
			} else {
				print "Sollten Fehler bei der Darstellung der Tabelle auftreten, kann die Tabelle hier neu initialsiert werden:".br;
				print start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}");
				print submit('Update-Tabelle'),end_form;	
			}
			print br.br.br;
		}

		print "<div class=Headline>Layout der Tabellen festlegen</div>".br;
		print "Einfach die Werte 1,2,3,4... in aufsteigender Reihenfolge so in die Felder verteilen, wie
		spter die Spalten angezeigt werden sollen.".br.br;
		my @tkeys = qw(TeamName POS TeamNamePos Rank
			Won  Lost  Draw  Total  LP GLP LP_Total PCT  TotalPoints PDifference 
			Home  Road  L10  Streak Main_Group_Result Sub_Group_Result GB Special TeamRate);
		
		if ($q->param('Tabelle speichern')) {
			my $ok = 1;
			my @Felder;
			my @Values;
			my @Felder2;
			my @Values2;
			foreach my $F (@tkeys) {
				push (@Felder2, "`$F`");
				push (@Values2, $LSC{MySQL}->quote($q->param("name-$F")));
				if (!($q->param($F)=~/[^0-9]/)) {
					push (@Felder, "`$F`");
					push (@Values, $LSC{MySQL}->quote($q->param($F)));
				} else {
					$ok=0;
				}
			}
			if ($ok) {
				push (@Felder, 'League');
				push (@Values, $LSC{MySQL}->quote($LSC{League}));
				push (@Felder2, 'League');
				push (@Values2, $LSC{MySQL}->quote($LSC{League}));
				
				my $do	= "replace into lsc_leagues_tabelle (".join(', ', @Felder).") Values (".join(', ',
					@Values).")";
				my $sth = $LSC{MySQL}->do("$do");
				$sth = $LSC{MySQL}->do("replace into lsc_leagues_tabelle_namen (".join(', ', @Felder2).") Values (".join(', ',	@Values2).")");
				print "<b>Neue Tabellenwerte wurden gespeichert. ACHTUNG: Sortierung kontrollieren!</b>".hr;
			} else {
				print "<b>Werte konnten nicht gespeichert werden, da unerlaubte Zeichen enthalten waren!</b>".br;
			}
		}
		print start_form('post',"$scriptname?League=$LSC{League}&Action=C_Tabelle");
		
		$select	= "select * from lsc_leagues_tabelle where League=$LSC{League}";
		$sth = $LSC{MySQL}->prepare("$select");
		$sth->execute();
		my $tabelle = $sth->fetchrow_hashref();
		$sth->finish;
		$select	= "select * from lsc_leagues_tabelle_namen where League=$LSC{League}";
		$sth = $LSC{MySQL}->prepare("$select");
		$sth->execute();
		my $tabellenamen = $sth->fetchrow_hashref();
		$sth->finish;

		$LSC{TEXT}{Admin}{Tabelle}[0] = "Name des Teams"; #TeamName
		$LSC{TEXT}{Admin}{Tabelle}[1] = "Tabellen Platzierung: X."; #POS
		$LSC{TEXT}{Admin}{Tabelle}[2] = "Name des Teams mit Platzierung in Klammern dahinter"; #TeamNamePos
		$LSC{TEXT}{Admin}{Tabelle}[3] = "Es wird ein RankName entsprechend der LP ausgegeben, nheres auf Anfrage...";
		$LSC{TEXT}{Admin}{Tabelle}[4] = "Siege";
		$LSC{TEXT}{Admin}{Tabelle}[5] = "Niederlagen";
		$LSC{TEXT}{Admin}{Tabelle}[6] = "Unentschieden";
		$LSC{TEXT}{Admin}{Tabelle}[7] = "Gesamtanzahl der Spiele";
		$LSC{TEXT}{Admin}{Tabelle}[8] = "LigaPunkte(nur Positiv)";
		$LSC{TEXT}{Admin}{Tabelle}[9] = "LigaPunkte (nur Negativ)";
		$LSC{TEXT}{Admin}{Tabelle}[10] = "LigaPunkte als X:Y anzeigen, wobei X die erzielten LigaPunkte darstellen und Y die Punkte, die alle Gegner gegen dieses Team erziehlt haben.";
		$LSC{TEXT}{Admin}{Tabelle}[11] = "Prozent der Siege";
		$LSC{TEXT}{Admin}{Tabelle}[12] = "Punkte A:B bei Fussball die erzielten Tore";
		$LSC{TEXT}{Admin}{Tabelle}[13] = "Punkte Differenz";
		$LSC{TEXT}{Admin}{Tabelle}[14] = "Heimbilanz";
		$LSC{TEXT}{Admin}{Tabelle}[15] = "Auswrtsbilanz";
		$LSC{TEXT}{Admin}{Tabelle}[16] = "Bilanz in den letzten 10 Spielen";
		$LSC{TEXT}{Admin}{Tabelle}[17] = "Streak/aktuelle Serie";
		$LSC{TEXT}{Admin}{Tabelle}[18] = "Bilanz in der Hautpgruppe";
		$LSC{TEXT}{Admin}{Tabelle}[19] = "Bilanz in der Zweitgruppe";
		$LSC{TEXT}{Admin}{Tabelle}[20] = "Games behind (siehe NBA.com)";
		$LSC{TEXT}{Admin}{Tabelle}[21] = "Gesamt OverTime/Verlngerungen";
		$LSC{TEXT}{Admin}{Tabelle}[22] = "Bewertung des Teams";

		print "<table cellspacing=3 border=0 width=100%>";
		print "<tr>";
			print "<td></td>";	
			print "<td align=center>Position in<br>der Tabelle</td>";	
			print "<td align=center>Spaltenberschrift<br>(max. 10)</td>";	
		print "</tr>";
		for (my $i=0;$i<=22;$i++) {
			print "<tr>";
				print "<td class=Headline>$LSC{TEXT}{Admin}{Tabelle}[$i] ($tkeys[$i])</td>";	
				print "<td align=center>".$q->textfield(-name=>$tkeys[$i], -size=>3, -default=>$tabelle->{$tkeys[$i]})."</td>";	
				print "<td align=center>".$q->textfield(-name=>"name-$tkeys[$i]", -size=>10,	-default=>($tabellenamen->{$tkeys[$i]} || $tkeys[$i]))."</td>";	
			print "</tr>";
		}
		print "</table>";
		print submit('Tabelle speichern'),end_form;
		print hr;
		
		# sortierung
		print "<div class=Headline>Sortierung der Tabelle</div>".br;
		my @okeys = qw(W L D LP PD Games);
		if ($q->param('Sortierung speichern')) {
			my %check = qw(W Won L Lost D Draw LP LP PD PDifference Games Games);
			my $ok = 1;
			my @Felder;
			my @Values;
			foreach my $F (@okeys) {
				if (!($q->param("o$F")=~/[^0-9\-]/)) {
					if ($q->param("o$F")) {
						if (!$tabelle->{$check{$F}} && $F ne "Games") {
							$ok =0;
							print "<font size=+1>Es kann nicht nach $F sortiert werden, wenn der
							entsprechende Wert nicht im oberen Men ausgewhlt wurde!</font>".br;
						}
					
					}
					push (@Felder, $F);
					push (@Values, $LSC{MySQL}->quote($q->param("o$F")));
				} else {
					print $F.br;
					$ok=0;
				}
			}
			if ($ok) {
				push (@Felder, 'League', 'Name');
				push (@Values, $LSC{MySQL}->quote($LSC{League}), 5);
				my $do	= "replace into lsc_leagues_tabelle_order (".join(', ', @Felder).") Values (".join(', ',
				@Values).")";
				my $sth = $LSC{MySQL}->do("$do");
				print "<b>Neue Sortierung wurden gespeichert.</b>".hr;
			} else {
				print "<font size=+1><b>Werte konnten nicht gespeichert werden, da unerlaubte Zeichen enthalten waren!</b></font>".br;
			}
		}
		print start_form('post',"$scriptname?League=$LSC{League}&Action=C_Tabelle");
		
		$select	= "select * from lsc_leagues_tabelle_order where League=$LSC{League}";
		$sth = $LSC{MySQL}->prepare("$select");
		$sth->execute();
		$ref = $sth->fetchrow_hashref();
		$sth->finish;
		print "<table cellspacing=0><tr>";
#		foreach (@okeys) {		print "<td class=Headline width=50>$_</td>";	}
		print "</tr>";
#		print "<tr>";
		my $SortLabel = {0=>"nicht sortieren", 
						1=>"1. aufsteigend", -1=>"1. absteigend",
						2=>"2. aufsteigend", -2=>"2. absteigend",
						3=>"3. aufsteigend", -3=>"3. absteigend",
						4=>"4. aufsteigend", -4=>"4. absteigend",
						5=>"5. aufsteigend", -5=>"5. absteigend",
						6=>"6. aufsteigend", -6=>"6. absteigend"};
		my $Namen = {W=>"Siege", L=>"Niederlagen", D=>"Unentschieden",
					LP=>"Liga Punkte", PD=>"Punkte/Tor Differenz", Games=>"Anzahl der eingetragenen Ergebnisse"};
		foreach (@okeys) {		
			print "<tr><td>".$Namen->{$_}." ($_)</td><td>".$q->popup_menu(-name=>"o$_", -values=>[0,1,-1,2,-2,3,-3,4,-4,5,-5,6,-6], -Labels=>$SortLabel, -default=>$ref->{$_})."</td></tr>";
			#print "<td align=center>".$q->textfield(-name=>"o$_", -size=>3, -default=>$ref->{$_})."</td>";	
		}
#		print "</tr>";
		print "</table>";
		print submit('Sortierung speichern'),end_form;
		print hr;		
}

sub AdminAdminStatus {
		print "<div class=Headline>LigaAdmins verwalten</div>";
		print "ACHTUNG! Jeder Admin der hinzugefgt wird, hat dieselben Rechte wie DU!!! Er kann also auch weitere
		Admins hinzufgen oder lschen und alle Daten der Liga manipulieren!!! Also gebe nicht jedem diesen
		Adminstatus!".br." ".br.br;
			my $Adminid;
			if (($Adminid=TeamSuchen($scriptname, "League=$LSC{League}&Action=C_Admins", 2))) {
				if (IsAnAdminForThisLeague($Adminid)) {
					print "Dieser User ist bereits Admin fr diese Liga.".br;
				} else {
					my $do = "replace lsc_leagues_admins (League, User) 
						Values ('$LSC{League}', '".$Adminid."')";
						my $sth = $LSC{MySQL}->prepare($do);
					$sth->execute();
					$sth->finish;
					print "Admin wurde hinzugefgt.";
				}
				print "<A HREF=\"admin.pl?League=$LSC{League}&Action=C_Admins\">Weitere Admins hinzufgen oder neue Suche</A>".br;
				print br;
			}
			
		print "<div class=Headline>Admins der Liga</div>".br;
			if ($q->param('Admin loeschen') && $q->param('AdminID')) {
				if ($q->param('AdminID') eq $LSC{userid} && $LSC{UserStatus} != 9) {
					print "Du kannst dich nicht selbst lschen!".br;
				} else {
					my $do = "delete from lsc_leagues_admins where League=$LSC{League} and
					User=".$LSC{MySQL}->quote($q->param('AdminID'));
					my $sth = $LSC{MySQL}->do($do);
					print "Admin wurde gelscht".br;
				}
				print br;
			}

		if ((my @admins = AdminsForThisLeague())) {
			foreach my $a (@admins) {
				my $user = UserKontaktDatenFromUserID($a);
				print start_form('post',"$scriptname?League=$LSC{League}&Action=C_Admins");
				print $q->hidden('AdminID', $a);
				print $user->{Login}."  ".submit('Admin loeschen').end_form;

			}
			print br;
			
		}
}

#############
#################### Ergebnisse verwalten
#############
sub AdminGames {
	print "Funktionen zu Verwaltung eingetragener Spiele:".br.br;
	print "<a href=$scriptname?League=$LSC{League}&Action=NewGame>Neues Ergebnis/Ergebnis freischalten/besttigen</a>".br;
	print "<a href=$scriptname?League=$LSC{League}&Action=DeleteAllGames>Alle Ergebnisse eines Teams/Users lschen (full version only)</a>".br;
	print "<a href=$scriptname?League=$LSC{League}&Action=DeleteAllLeagueGames>Alle Ergebnisse der Liga lschen (full version only)</a>".br;
	print br;
	AdminSpielmanipulieren();
	print br.br;
	AdminTeamDatenAktualisieren();
}	
sub AdminTeamDatenAktualisieren {
	print "Wurden nderungen an Ergebnissen durchgefhrt, z.b. Ergebnisse manipuliert oder gelscht, dann muss die Punktdatenbank aktualisiert werden. Die Aktualisierung wird automatisch durchgefhrt. In manchen Situation kann aber eine manuelle Aktualisierung notwendig sein, wenn die Ergebnis/Statistikseiten nicht richtig angezeigt werden.<br>Um die Werte zu aktualisieren unten das gewnschte Team oder den gewnschten User auswhlen und auf aktualisieren klicken.<br>Sollen alle Teams aktualisiert werden, musst dieses ein User machen, der den GlobalAdmin Status hat, da diese Aktion je nach gre der Liga die Datenbank stark beanspruchen kann.<br>".br;


	my %Members = Members();
	if ($q->param("Team")) {
		print "<b>Aktualisieren:</b>".br;
		if ($Members{$q->param("Team")}) {
			print "Aktualisiere Daten von ".$Members{$q->param("Team")}." ... ";
			Require("LSCPoints.pm");
			Points_TeamAktualisieren($q->param("Team"), $LSC{League});
			print "fertig".br;
		} elsif ($q->param("Team") eq '[update all]' &&
					$LSC{UserStatus} == 9) {
			Require("LSCPoints.pm");
			foreach my $mem (keys %Members) {
				print "Aktualisiere Daten von ".$Members{$mem}." ... ";
				Points_TeamAktualisieren($mem, $LSC{League});
				print "fertig".br;
			}
		} else {
			print "Das gewhlte Team ist nicht in dieser Liga!".br;
		}
		print br.br;

	}
	print "Team-/Userdaten aktualisieren:".br;
	$q->delete('Team');
	print start_form('post',"admin.pl?League=$LSC{League}&Action=TeamUpdate");
	print $q->popup_menu(-name=>'Team', -values=>[sort {"\L$Members{$a}" cmp
			"\L$Members{$b}" } keys %Members, '[update all]'], -Labels=>\%Members), "   ";
	print submit('aktualisieren'),end_form;	

}
sub AdminNeuesSpielForderung {
	if ($q->param("Forderung")) {
		AdminNeuesSpiel(@_);
		return;
	} 
	$q->param("Forderung", $_[1]);
	AdminNeuesSpiel($_[0]);

}

sub AdminNeuesSpiel {
	print "<a href=$scriptname?League=$LSC{League}&Action=Games>Spiel verwalten, uebersicht</a>".br;
	print hr;
	my ($Action2, $Special) = @_;

	if ($LSC{LeagueData}{Spielplan}) {
		print "Fr diese Liga wird ein Spielplan genutzt! Damit das eingetragene Ergebnis korrekt im Spielplan angezeigt wird, muss darauf geachtet werden welches Team im Spielplan Heimrecht hat, also auf der linken Seite steht. Diese Team muss im Formular oben ausgewhlt werden. Das Auswrtsteam muss unten stehen!".br.br;
	}

	$LSC{ErgebnisAdminMod} =1;#
	Require("LSCErgebnisse2.pm");
	ErgebnisseNeu($Action2, $Special);

}
sub AdminSpielLoeschen {
		# Spiel lschen
		my $no = shift || 0;
		if (!$no || $no =~/[^0-9]/) {
			print "Die bergebende GameID ist ungltig. Das Ergebnis kann nicht gelscht werden.".br;
			return;
		}
		
		# GameDaten
		my $sth = $LSC{MySQL}->do("Delete FROM lsc_games_daten WHERE League=$LSC{League} and No=$no");
		# TeamDaten
		$sth = $LSC{MySQL}->do("Delete FROM lsc_games WHERE Game=$no");
		# Kommentare
		$sth = $LSC{MySQL}->do("Delete FROM lsc_games_comment WHERE Game=$no");
		# Berichte
		$sth = $LSC{MySQL}->do("Delete FROM lsc_games_recap WHERE No=$no");
		# SystemKommentare
		$sth = $LSC{MySQL}->do("Delete FROM lsc_games_syscom WHERE ID=$no");
		# falls TurnierErgebnis dieses lschen
		$sth = $LSC{MySQL}->do("update lsc_playoffs_round set GameID=0 where League=$LSC{League} and GameID=$no");
		# PlayerStats
		if ($LSC{PlayerStats}) {
			PlayerStatsDeleteGame($no);
		}

		#mgliche upload files lschen:
		#uploadpfad existiert?
		my $dir = "$LSC{uploadpfad}League-$LSC{League}";
		if (-e $dir) {
		    if (opendir DIR, $dir) {
				foreach ( readdir DIR ) {
					if ($_ =~ /^LigaScript\-$no\-/) {
						unlink("$dir/$_");
					}
				}
				closedir DIR;
			}
		}

		#print "Spiel wurde gelscht.".br;
}
sub AdminSpielmanipulieren {

	print "<a href=$scriptname?League=$LSC{League}&Action=Games>Spiel verwalten, uebersicht</a>".br;
	print hr;
	if ($_[1] && !$q->param('GameID')) {
		$q->param('GameID', $_[1]);
	}

	local *Form = sub {
		print "Spielnummer des Spiels eingeben, deren Daten manipuliert werden sollen.".br;
		print "Die Spielnummern findest Du in der Ergebnisliste der Liga.".br;
		print br;
		print start_form('post',"$scriptname?League=$LSC{League}&Action=ChangeGame&Action2=show");
		print "Spielnummer: ", $q->textfield('GameID', '', 4),"&nbsp;&nbsp;&nbsp;";
		print submit('show'),end_form;
	};
	if ($LSC{Action2} eq 'show' && $q->param('GameID')) {
		if ($q->param('GameID') =~/[^0-9]/) {
			print "Die Spielnummer besteht nur aus Zahlen.".br;
			print hr;
			Form();
			return;
		}
		print "<b>Spieldaten (".$q->param('GameID')."):</b>".br;
		my $Spiel = SpieldatenLaden($q->param('GameID'));
		if ($Spiel) {
			print "<table border=1 width=100%><tr><td>";
			SpieldatenAnzeigen($Spiel);
			print "</td></tr></table>\n";
			print br;
			print "<b>Spieldaten verndern:</b>".br;
			
			print start_form('post',"$scriptname?League=$LSC{League}&Action=ChangeGame&Action2=change");
			print $q->hidden('GameID');

			my ($T1, $T2) = GameTeamDatenLaden($q->param('GameID'));

			print "<table cellspacing=0>";
			local *zeilezeigen = sub {
				print "<tr>\n";
					foreach (@{$_[0]}) {
						print "<td $_[1]>$_</td>";
					}
						
				print "</tr>\n";
			};
			zeilezeigen([qw(ID Game Team Points LP Won Lost Draw)], "class=Headline");

			my ($Teamname, undef) = TeamnameAndUserFromTeamIDAndLeague($T1->{Team}, $LSC{League});
			zeilezeigen([$T1->{ID}, $T1->{Game}, $Teamname." ($T1->{Team})", 
			$q->textfield("Points-$T1->{ID}", $T1->{Points}, 4),
			$q->textfield("LP-$T1->{ID}", $T1->{LP}, 4),
			$q->textfield("Won-$T1->{ID}", $T1->{Won}, 1),
			$q->textfield("Lost-$T1->{ID}", $T1->{Lost}, 1),
			$q->textfield("Draw-$T1->{ID}", $T1->{Draw}, 1)],
			"");
			($Teamname, undef) = TeamnameAndUserFromTeamIDAndLeague($T2->{Team}, $LSC{League});
			zeilezeigen([$T2->{ID}, $T2->{Game}, $Teamname." ($T2->{Team})", 
			$q->textfield("Points-$T2->{ID}", $T2->{Points}, 4),
			$q->textfield("LP-$T2->{ID}", $T2->{LP}, 4),
			$q->textfield("Won-$T2->{ID}", $T2->{Won}, 1),
			$q->textfield("Lost-$T2->{ID}", $T2->{Lost}, 1),
			$q->textfield("Draw-$T2->{ID}", $T2->{Draw}, 1)],
			"");
			print "</table>";
			print "Es wird nicht berprft, ob die eingegeben Werte einen Sinn ergeben bzw. ob die eingetragenen Werte fr die gewhlte Liga verwendbar sind. ";
			print "Deshalb berlege Dir genau was Du tust!".br;
			print "Fr die Felder 'Won', 'Lost' und 'Draw', sind nur die Werte 0 und 1 zulssig. In den anderen Feldern knnen beliebige (positive/negative) Integerwerte verwendet werden. ";
			print br.br;
			my $sys = RecapSystemComment($q->param('GameID'));
			print "System-Kommentar:", br, $q->textarea('syscom',$sys,5,65);
			print "\n",br,submit('save Game'),end_form;
			print start_form('post',"$scriptname?League=$LSC{League}&Action=ChangeGame&Action2=delete");
			print $q->hidden('GameID');
			print submit('delete Game'),end_form;
			print br.br;
			print "<b>Beispiele:</b>",br;
			print "\n- Hat ein Spiel stattgefunden, soll aber, wegen einem Regelverstoss, anders gewertet werden, dann knnen hier direkt die Werte manipuliert werden. Hat z.B. A gegen B gewonnen, wobei A gegen eine Regel verstossen hat, die Strafpunkte zur Folge hat, so zieht man einfach von den angegeben Ligapunkten(LP) die Strafpunkte ab und trgt die neuen Ligapunkte ein, dabei sind auch negative Ligapunkte mglich.".br;
			print "\n- Wurde eine Begegnung nicht gespielt, weil sich z.B. die beiden Spieler nicht auf ein Spieltermin einigen konnten, so trgt man zunchst ber 'Add Game' ein neues Spiel, ruft dann die Seite 'Change Game' auf und setzt die Werte fr 'Won', 'Lost' und 'Draw' auf 0, dadurch wird dieses Ergebnis nicht als Sieg, Niederlage oder Unentschieden gewertet. Nun kann man noch in der Spalte Ligapunkte(LP) Strafpunkte (Minuswerte) verteilen.".br;
			print "\n- Default Win... tritt ein Spieler nicht zum Spiel an, so kann ein Admin ber 'Add Game' ein Spiel eintragen und es danach ber 'Change Game' so verndern, dass den 'eigenen' Regeln entsprechend, Punkte verteilt werden, bzw. abgezogen werden.".br;
			
		} else {
			print "Dieses Spiel existiert nicht oder gehrt nicht zu dieser Liga.".br;
			Form();		
		}	
	} elsif ($LSC{Action2} eq 'change' && $q->param('GameID')) {
		if ($q->param('GameID') =~/[^0-9]/) {
			print "Die Spielnummer besteht nur aus Zahlen.".br;
			print hr;
			Form();
			return;
		}
		my $Spiel = SpieldatenLaden($q->param('GameID'));
		if ($Spiel) {
			my ($T1, $T2) = GameTeamDatenLaden($q->param('GameID'));

			my $do = 'update lsc_games set ';
			my @set =();
			# ID Game Team ...
			foreach (qw(Points LP Won Lost Draw)) {
				push(@set, $_."=".$LSC{MySQL}->quote($q->param($_."-".$T1->{'ID'})));
			}
			my $sth = $LSC{MySQL}->do("$do ".join(', ', @set)." where ID=$T1->{'ID'}");

			@set =();
			foreach (qw(Points LP Won Lost Draw)) {
				push(@set, $_."=".$LSC{MySQL}->quote($q->param($_."-".$T2->{'ID'})));
			}
			$sth = $LSC{MySQL}->do("$do ".join(', ', @set)." where ID=$T2->{'ID'}");

			#Sys Com
			my $message = $q->param('syscom')."\nmodified by Admin($LSC{userid}), $LSC{date}";
			$sth = $LSC{MySQL}->do("update lsc_games_syscom set Message=".
				$LSC{MySQL}->quote($message)." where ID=".$q->param('GameID'));

			print "Spiel wurde gespeichert.".br;
		} else {
			print "Die bertragenden Daten stimmen nicht mit den erwarteten Daten berein!";
		}			

	} elsif ($LSC{Action2} eq 'delete' && $q->param('GameID')) {
		if ($q->param('GameID') =~/[^0-9]/) {
			print "Die Spielnummer besteht nur aus Zahlen.".br;
			print hr;
			Form();
			return;
		}
		if ($q->param('confirm')) {
			AdminSpielLoeschen($q->param('GameID'));
			print "Spiel wurde gelscht.".br;
		} else {
			print start_form('post',"$scriptname?League=$LSC{League}&Action=ChangeGame&Action2=delete");
			print $q->hidden('GameID');
			print $q->hidden('confirm', 1);
			print "Wirklich lschen? ";
			print submit('JA'),end_form;
		}

	} else {
		Form();
	}

}
#########
################# Spielplan
########

sub AdminSpielplanInitialisierung {
	unless ($LSC{LeagueData}{Spielplan}) {
		print "Spielplanfunktionen stehen hier nicht zur Verfgung!".br;
		return;
	}
	
	print "<b>Spielplan-Initialisierung:</b>".br.br;
	if (Liga_AnzahlSpiele($LSC{League}) > 0) {
		print "Der Spielplan kann nicht neu initialisiert werden, da bereits Spiele eingetragen worden sind!".br;
#		return;
	}

	
	if ($q->param('initialisieren') && 
				$q->param('Anzahl') !~/[^0-9]/ &&
					$q->param('Anzahl') <= 30 &&
						$q->param('Anzahl') >=3
			) {
			# Spielplan mit sortierten TeamID initialisieren
			my %Members = Members();
			my @Members = sort {$a <=> $b}keys %Members;
			for (my $i=0; $i < $q->param('Anzahl'); $i++) {
				$Members[$i] = 0 if (!$Members[$i]);
			}
			my $Spielplan = join ('|', @Members);

			#alte einstellungen lschen
			$sth = $LSC{MySQL}->do("delete FROM lsc_leagues_spielplan where League=$LSC{League}");	

			#neue einstellungen speichern
			my $a = $q->param('Anzahl');
			$sth = $LSC{MySQL}->do("insert into lsc_leagues_spielplan (League, TOrder, TCount) values ($LSC{League}, '$Spielplan', $a)");	
			print "Spielplan wurde gespeichert.".br;
		return;
	} elsif($q->param('initialisieren')) {
		print "Spielplan kann nicht initialisiert werden, da die bergebenen Daten ungltig sind!!".br.br;
	}

	print start_form('post',"$scriptname?League=$LSC{League}&Action=C_SpielplanInit");
	print "Anzahl der Teams, fr die ein Spielplan erzeugt werden soll (zur Zeit maximal 30 Teams, minimal 3):".br;
	print $q->textfield('Anzahl');
	print submit('initialisieren'),end_form;

}
sub AdminSpielplanErstellenBeenden {
	if ($q->param('delete')) {
		if ($q->param('confirm')) {
			print "Spielplan wird gelscht ...".br;
			my $sth = $LSC{MySQL}->do("delete from lsc_leagues_spielplan where League=$LSC{League}");	
			print "fertig!".br.br;
			print "Spielplanfunktion wird deaktiviert ...".br;
			$sth = $LSC{MySQL}->do("update lsc_leagues set Spielplan=0, AnzahlSpiele=0 where League=$LSC{League}");	
			print "fertig!".br;
			return;
		} else {
			print "Soll der Spielplan wirklich gelscht werden?".br;
			print "Diese Aktion kann nicht rckgngig gemacht werden, der Spielplan kann also nicht widerhergestellt werden!".br;
			print $q->start_form('post',"admin.pl?League=$LSC{League}&Action=C_SpielplanEnde");
			print $q->submit('Spielplan lschen');
			print $q->hidden('delete', 1),$q->hidden('confirm', 1),$q->end_form;
			return;
		}
	}
	if ($q->param('create')) {
		if ($q->param('Spielplan') eq "1" ||
				$q->param('Spielplan') eq "2") {
			my $Spielplan = $q->param('Spielplan');
			my $AnzahlSpiele = 1;
			my $ok = 1;
			if ($Spielplan eq "2") {
				if ($q->param('AnzahlSpiele') eq "1" ||
					$q->param('AnzahlSpiele') eq "2") {
					$AnzahlSpiele = $q->param('AnzahlSpiele');
				} else {
					print "Die Angaben fr Hin-/Rckspiel sind ungltig!";
					$ok = 0;
				}
			}
			if ($Spielplan eq "1" && $q->param('AnzahlSpiele') eq "2") {
				print "Wenn Hin-/Rckspiel gewhlt wurde muss der strenge Spielplan ausgewhlt werden!";
				$ok = 0;
			}
			if ($ok) {
				print "Spielplan wird aktiviert ...".br;
				my $sth = $LSC{MySQL}->do("update lsc_leagues set Spielplan=$Spielplan, AnzahlSpiele=$AnzahlSpiele where League=$LSC{League}");	
				print "fertig!".br.br;

				print "Der Spielplan muss nun initialisiert werden, dazu sollten mglichst bereits alle Teams der Liga hinzugefgt worden sein, die an der Liga teilnehmen sollen. Ausserdem muss bekannt sein wie viele Teams teilnehmen werden.".br;
				print "Der Spielplan kann auch spter initialisiert werden, dazu einfach auf Einstellungen -&gt Punkt:Spielplan -&gt Spielplan-Initialisieren klicken.".br.br;
				print "<A HREF=\"admin.pl?League=$LSC{League}&Action=C_SpielplanInit\">Spielplan jetzt Initialisierung</A>".br;
				return;
			} else {
				print br.br.br;
			}
		} else {
			print "Es wurden ungltige Angaben bermittelt!".br;
		}

	}
	if ($LSC{LeagueData}{Spielplan}) {
		print "Um die Nutzung des Spielplans zu beenden, einfach unten auf den Button klicken. Der Spielplan kann nicht wiederhergestellt werden! Ausserdem ist es nicht mglich den Spielplan neu einzurichten, wenn bereits Ergebnisse eingetragen wurden!".br;
		print $q->start_form('post',"admin.pl?League=$LSC{League}&Action=C_SpielplanEnde");
		print $q->submit('Spielplan lschen');
		print $q->hidden('delete', 1),$q->end_form;

	} else {
		if ($LSC{LeagueData}{PlayoffDaten}) {
			print "Es kann kein Spielplan genutzt werden, wenn ein Turniermodus gewhlt wurde!".br;
			return;
		} elsif (Liga_AnzahlSpiele($LSC{League})) {
			print "Es kann kein Spielplan erstellt werden, wenn bereits Spiele eingetragen wurden!".br;
	#		return;
		}
		print "Um einen Spielplan zu nutzen flle das untenstehende Formular aus:".br;
		print $q->start_form('post',"admin.pl?League=$LSC{League}&Action=C_SpielplanEnde");
		print "Spielplan art whlen:".br;
		print "- einfach: der Spielplan dient nur zur bersicht, beim Eintragen von Ergebnissen muss man sich also nicht nach dem Spieltag richten. Zur Zeit wird in diesem Modus nur ein Spiel, also sozusagen die Hinrunde untersttzt. In einenm der kommenden Updates wird dieser Punkt erweitert.".br;
		print "- streng: es knnen nur Ergebnisse fr den aktuellen (ber Adminbereich einstellbar) Spieltag eingetragen werden. Admins knnen jedoch ausserhalb des aktuellen Spieltages Ergebnisse eintragen, dabei muss aber genau beachtet werden, welches Team Heimrecht (steht im Spielplan auf der linken Seite) hat, damit die Ergebnisse korrekt angezeigt werden.".br;
		print "Spielplan-Art: ".$q->popup_menu(-name=>'Spielplan', -values=>[1,2], -Labels=>{1=>'einfach',	2=>'streng'}).br;
		print "Wenn der \"strenge\" Spielplan gewhlt wurde, kann hier ausgewhlt werden wieviele Ergebnisse eingetragen werden knnen:".br;
		print "Anzahl Spiele: ".$q->popup_menu(-name=>'AnzahlSpiele', -values=>[1,2], -Labels=>{1=>'nur Hinspiele (ein Ergebnis)',	2=>'Hin- und Rckspiel (2 Ergebnisse)'}).br;
		print "ACHTUNG: Wenn Hin+Rckspiel gewhlt wurde, dann kann spter immer nur das Hinspiel als erstes und dan das Rckspiel eingetragen werden! Die Reihenfolge ist also durchs Script vorgegeben!" .br;

		print $q->submit('Spielplanfunktion aktivieren');
		print $q->hidden('create', 1),$q->end_form;
	}
}
1