
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




# Results
# GamesOverview

sub Results {
	# Liga verwendet einen Spielplan
		if ($LSC{LeagueData}{Spielplan}) {
			#	old:
			#	my $AnzahlTeams = Liga_AnzahlteilnehmenderUser($LSC{League});
			#   new:
			my $AnzahlTeams = SpielplanTeamAnzahlLaden();
			my $Spieltage = ($AnzahlTeams + ($AnzahlTeams%2)) -1;
			my $RueckSpiel = 0;
			if ($LSC{LeagueData}{AnzahlSpiele} == 1) {
				#alles ok
			} elsif ($LSC{LeagueData}{AnzahlSpiele} == 2) {
				#alles ok

				#auch Rckspiel! also Doppelt so viele Spieltage
				$RueckSpiel = $Spieltage;
				$Spieltage+=$Spieltage;

			} else {
				print "Bitte Spielplan Daten berprfen! Anzahl Spiele wurde nicht festgelegt!".br;
			}
			my $Spieltag = shift || $LSC{Spieltag} || 1;

			print '<table align=center width="90%"><tr><td width=50>';
			print '<table>';
			for (my $s=1;$s<=$Spieltage/2;$s++) {
				print '<tr><td>';
				if ($RueckSpiel && ($RueckSpiel+1 == $s)) {
#					print "---".br;
				}
				if ($s == $Spieltag) {
						print "[&nbsp;$s.&nbsp;]";
				} else {
					print "<a class=standard href=$scriptname?".
					"League=$LSC{League}&Action=Results&Action2=$s><b>$s.</b></a>";
				}
				if ($RueckSpiel) {
					print '</td><td width=50>';
					my $ss = $s +$RueckSpiel;
					if ($ss == $Spieltag) {
						print "[&nbsp;$ss.&nbsp;]";
					} else {
						print "<a class=standard href=$scriptname?".
						"League=$LSC{League}&Action=Results&Action2=$ss><b>$ss.</b></a>";
					}

				}
				print '</td></tr>';
			}
			print '</table>';
			print "</td><td>";
			if ($Spieltag > $Spieltage) {
				print "Es gibt nur $Spieltage Spieltage!".br;
				SpielplanAnzeigen(1);
			} else {
				SpielplanAnzeigen($Spieltag);
			}
			print "</td></tr></table>";
			if ($LSC{LeagueData}{Spielplan} == 1) {
				print br.br;
				GamesOverview(shift || 1)
			}
			return;
		}
	# /Liga verwendet einen Spielplan
	# Pokalmodus
		if ($LSC{LeagueData}{PlayoffDaten}{'PokalBestOf'}) {
			PlayoffPokalErgebnisse(@_);
			return;
		}
	# /Pokalmodus
	GamesOverview(shift || 1);
	
}
sub CountGameComments {
	my $game = shift;
	unless ($game) {return 0;}

	my $sth1;
	my $sth2;

	if ($LSC{sth}{CountGameComments1}) {
		$sth1 = $LSC{sth}{CountGameComments1};
	} else {
		$LSC{sth}{CountGameComments1} = $LSC{MySQL}->prepare("SELECT count(*),min(TO_DAYS(NOW()) - TO_DAYS(Date)) FROM lsc_games_comment WHERE Game=?");
		$sth1 = $LSC{sth}{CountGameComments1};
	}
	if ($LSC{sth}{CountGameComments2}) {
		$sth2 = $LSC{sth}{CountGameComments2};
	} else {
		$LSC{sth}{CountGameComments2} = $LSC{MySQL}->prepare("SELECT count(*),min(TO_DAYS(NOW()) - TO_DAYS(Date)) FROM lsc_games_recap WHERE No=?");
		$sth2 = $LSC{sth}{CountGameComments2};
	}
	
	$sth1->execute($game);
	my $ref = $sth1->fetchrow_arrayref();
	$sth1->finish;
	
	$sth2->execute($game);
	my $ref2 = $sth2->fetchrow_arrayref();
	$sth2->finish;
	
	if (!$ref->[0] && !$ref2->[0]) { return "-";}
	
	my $days = defined($ref->[1]) && $ref->[1] < ($ref2->[1] || $ref->[1]) ? $ref->[1] : $ref2->[1] || $ref->[1];
	if (!$days || $days eq "0") { $days = $LSC{TEXT}{X}[4] }
	else {$days = $days."d"};
	
	my $comments = ($ref->[0] || 0) + ($ref2->[0] || 0);

	return $comments."/".$days;
}

sub GamesOverview {
	#Start, [TeamID], [Anzahl], [Headline], kein Men
	my $count = $_[2] || $LSC{anzahlspieleanzeigen};
	my $Start = $_[0] || 1;
	if ($count=~/[^0-9]/ || $Start=~/[^0-9]/) {
		print $LSC{TEXT}{ERROR}[1].br;
		return;
	}		
	my $AnzahlSpiele = Liga_AnzahlSpiele($LSC{League});
	unless ($AnzahlSpiele) {
		print $LSC{TEXT}{ERROR}[0];
		return;
	}
	
	my $Menue = '';
	if ($AnzahlSpiele >= $LSC{anzahlspieleanzeigen} && !$_[1] && !$_[4]) {
		local *mlink = sub {
			if ($_[0] == $Start) {
				$Menue .= "\[".$_[1]."\]";
			} else {	
				$Menue .= "<a class=E href=$scriptname?".
				"League=$LSC{League}&Action=Results&Action2=$_[0]>\[".
				$_[1]."\]</a>";
			}
		};
		my $c = 1;
		$Menue .=  "<div align=center>";
		while ($c < $AnzahlSpiele) {
			mlink($c, "$c-".($c + $LSC{anzahlspieleanzeigen} - 1));
			$Menue .=  " ";
			$c +=$LSC{anzahlspieleanzeigen};
		}
		$Menue .=  "</div>".br;
	}
	print "$Menue";
	$Start--;

	my $Template = TemplateLoad1($LSC{Templates}{'ErgebnisseLiga'});
	unless ($Template) {
		print "Konnte Template fr Ergebnisse nicht laden! ($!)".br;
		return;
	}
	print TemplateMaker($Template->{Head}, {"LSC-Headline"=>$_[3]});

	my $sth;
	if ($_[1]) {
		#teambersicht
		$sth = $LSC{MySQL}->prepare("SELECT d.No FROM lsc_games_daten d, lsc_games g  WHERE d.League=$LSC{League} and d.No=g.Game and g.Team=$_[1] Order by Date DESC Limit $Start,$count");
	} else {
		#ganze liga
		$sth = $LSC{MySQL}->prepare("SELECT No FROM lsc_games_daten WHERE League=$LSC{League} Order by Date DESC Limit $Start,$count");
	}
	$sth->execute();


	my $i = 0;
	my @Win = ('', 'W');
	my @Lost = ('', 'L');
	my @Draw = ('', 'D');
	my @Overtime = ('', '(OT)');

	Require("LSCErgebnisse2.get.pm");

		foreach my $ref (@{$sth->fetchall_arrayref()}) {
			my $layout = $i++ % 2;
			my $values = $i;
			my $Game = Ergebnisladen($ref->[0]);
			unless ($Game) {
				next;
			}
			my @Team1 = ();
			my @Team2 = ();
			my @SmallTeam1 = ();
			my @SmallTeam2 = ();
			my $team1 = "";
			my $team2 = "";
			foreach my $t1 (keys %{$Game->{home}}) {
				push @Team1, TeamLink($Game->{home}{$t1}{Name}, $t1, 'E',!$LSC{Vote}{S}{Ergebnisse});
				push @SmallTeam1, substr($Game->{home}{$t1}{Name}, 0, 1);
				$team1 = $t1 unless $team1;
			}

			foreach my $t2 (keys %{$Game->{away}}) {
				push @Team2, TeamLink($Game->{away}{$t2}{Name}, $t2, 'E',!$LSC{Vote}{S}{Ergebnisse});
				push @SmallTeam2, substr($Game->{away}{$t2}{Name}, 0, 1);
				$team2 = $t2 unless $team2;
			}

		
			$values = {	"LSC-Team1"=>join("<br>", @Team1), 
						"LSC-Team2"=>join("<br>", @Team2), 
						"LSC-Date"=>$Game->{Game}{Date},
						"LSC-Date2"=>$Game->{Game}{Date2},
						"LSC-Date3"=>$Game->{Game}{Date3},
						"LSC-Comments"=>CountGameComments($ref->[0]),
						"LSC-GameID"=>$ref->[0],
						};
			
			if (scalar(@SmallTeam1) == 1) {
				my $small = substr($Game->{home}{$team1}{Name}, 0, 5)."...";
				if (length($small) >= length($Game->{home}{$team1}{Name})) {
					$small = $Game->{home}{$team1}{Name};
				}
				$values->{"LSC-SmallTeam1"} = TeamLink($small, $team1, 'E',1);
			} else {
				$values->{"LSC-SmallTeam1"} = join(".", @SmallTeam1);
			}
			if (scalar(@SmallTeam2) == 1) {
				my $small = substr($Game->{away}{$team2}{Name}, 0, 5)."...";
				if (length($small) >= length($Game->{away}{$team2}{Name})) {
					$small = $Game->{away}{$team2}{Name};
				}
				$values->{"LSC-SmallTeam2"} = TeamLink($small, $team2, 'E',1);
			} else {
				$values->{"LSC-SmallTeam2"} = join(".", @SmallTeam2);
			}

			$values->{"LSC-Team1-WonLostDraw"} = $Win[$Game->{home}{$team1}{Won}].$Lost[$Game->{home}{$team1}{Lost}].$Draw[$Game->{home}{$team1}{Draw}];
			$values->{"LSC-Team2-WonLostDraw"} = $Win[$Game->{away}{$team2}{Won}].$Lost[$Game->{away}{$team2}{Lost}].$Draw[$Game->{away}{$team2}{Draw}];

			if ($LSC{PlayerStats}) {
				Require("LSCPlayerStatsBoxScores.pm");
				$values->{"LSC-BoxScores"} = PlayerBoxscoresVorhanden($ref->[0]) ? "(BS)":"";
				$values->{"LSC-PlayerStatsPTS"} = PlayerBoxscoresHighPts($ref->[0]);
				$values->{"LSC-PlayerStatsRebs"} = PlayerBoxscoresHighRebs($ref->[0]);
			}

			$values->{"LSC-Recap1"} = RecapLink($LSC{League}, $ref->[0], $Game->{home}{$team1}{Points}.":".$Game->{away}{$team2}{Points});
			$values->{"LSC-Recap2"} = RecapLink($LSC{League}, $ref->[0], $Game->{away}{$team2}{Points}.":".$Game->{home}{$team1}{Points});

			$values->{"LSC-Recap3"} = RecapLink($LSC{League}, $ref->[0], $values->{"LSC-Team1-WonLostDraw"}.":".$values->{"LSC-Team2-WonLostDraw"});
			$values->{"LSC-Recap4"} = RecapLink($LSC{League}, $ref->[0], $values->{"LSC-Team2-WonLostDraw"}.":".$values->{"LSC-Team1-WonLostDraw"});

			print TemplateMaker($Template->{"ErgebnisZeile".($layout+1)}, $values);
		}
	$sth->finish;

	print $Template->{Bottom};
	print br."$Menue";

	print $Template->{Info};
}

sub ShowResult {
	my ($Action, $Game) = @_;

			### Spieldaten laden:
		my $Spiel = SpieldatenLaden($Game);
		if ($Spiel) {
			if (my $error = $q->cgi_error) {
				print br.br;
				print "Achtung!!!!!!!!!!!!!!!!!!!!!!!!!!!".br;
				print "Die Kommentar/Spielbericht Maximalgre wurde berschritten!".br;
				print "Postings dieser grer sind nicht erlaubt!!!".br;
				print "($error)".br;
				print "Achtung!!!!!!!!!!!!!!!!!!!!!!!!!!!".br.br.br.br;
				print hr;
			} else {
				if ($LSC{LOGIN} && $q->param('submit') && $q->param('kommentar')) {
					my $T = $LSC{MySQL}->quote($q->param('kommentar'));
					my $sth = $LSC{MySQL}->do("insert into lsc_games_comment (Game, Author, Comment)
					Values ('$Spiel->[0]', '$LSC{userid}', $T)");	

					} elsif ($LSC{AllowAction} && $q->param('submit') && $q->param('recap')) {
					my $T = $LSC{MySQL}->quote($q->param('recap'));
					my $sth = $LSC{MySQL}->do("insert into lsc_games_recap (No, Author, Recap, TeamID)
					Values ('$Spiel->[0]', '$LSC{userid}', $T, $LSC{userteamid})");
	
				}
			}
			SpieldatenAnzeigen($Spiel);
			print '<A HREF="'.$scriptname.'?League='.$LSC{League}.'&Action='.$LSC{Action}.'&special='.$LSC{special}.'">[reload page]</A>'.br.br;
			#Playerstats / Boxscrores
			if ($LSC{PlayerStats}) {
				Require("LSCPlayerStatsBoxScores.pm");
				print '<div align=center>';
				PlayerBoxscoreTeamStats($Spiel->[0], $Spiel->[1],$Spiel->[3],$Spiel->[2],$Spiel->[4]);
				PlayerBoxscores($Spiel->[0], $Spiel->[1],$Spiel->[3],$Spiel->[2],$Spiel->[4]);
				print '</div>';
			print '<A HREF="'.$scriptname.'?League='.$LSC{League}.'&Action='.$LSC{Action}.'&special='.$LSC{special}.'">[reload page]</A>'.br;
			}
			if ($LSC{PlayerStats} && $LSC{AllowAction}) {
				PlayerBoxscoresUpload($Spiel->[0],  $Spiel->[1], $Spiel->[2]);
			}
			## recaps
			my %RecapTeams = Recaps($Spiel);
			RecapForm(\%RecapTeams);

			print br.br;
			print "Comments:".br;
			Comments($Spiel->[0]);	
			NewComment();
		} else {
			print $LSC{TEXT}{Ergebnisse}[56].br;
		}
}
sub Recaps {
	my ($select,$from,$where,$group,$order);
		$select	= "c.Recap, DATE_FORMAT(c.Date,'%e. %M'), u.Login, u.UserID, c.TeamID";
		$from	= "lsc_games_recap c, lsc_user u";
		$where	= "No=$_[0]->[0] and c.Author=u.UserID";
		$group	= "";
		$order	= "order by c.Date";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ok = 0;
	my %RecapTeams = ($_[0]->[1], 1, $_[0]->[2], 1);
	while (my $ref = $sth->fetchrow_arrayref()) {
		delete $RecapTeams{$ref->[4]};
		unless ($ok) { 
			print "Recaps:".br;
			print "<table width=100%>";
		}
		$ok = 1;
		my $c = RemoveHtmlFromText($ref->[0]);
		print "<tr>	<td width=100  valign=top >	".
				UserLink($ref->[2], $ref->[3]).
				'</td><td align=left style="border: 1px solid #8596B0">'.$c.'</td></tr>';
	}
	if ($ok) {
		print	"</table>";
	}
	$sth->finish;
	return %RecapTeams;
}
sub RecapForm {
	my $RC = shift;

	if ($LSC{AllowAction} && $RC->{$LSC{userteamid}}) {
		my $save="$scriptname?League=$LSC{League}&Action=$LSC{Action}&special=$LSC{special}";
		print    $q->start_form('post',$save);
		printtext ("Recap/Spielbericht:", 
				$q->textarea('recap','',10,65),br,br,
				$q->submit('submit'),
				$q->end_form);
	}
}
sub Comments {
	my ($select,$from,$where,$group,$order);
		$select	= "c.Comment, DATE_FORMAT(c.Date,'%e. %M'), u.Login, u.UserID, c.ID";
		$from	= "lsc_games_comment c, lsc_user u";
		$where	= "Game=$_[0] and c.Author=u.UserID";
		$group	= "";
		$order	= "order by c.ID";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();
	my $ok = 0;
	print "<table width=100%>";
	while (my $ref = $sth->fetchrow_arrayref()) {
		$ok = 1;
		my $c = RemoveHtmlFromText($ref->[0]);
		print '<tr><td width=100 align=top  align=left>'.
					UserLink($ref->[2], $ref->[3])." ".
					($LSC{Admin} ? 
						ShowLink({	Name => '<FONT COLOR="#FF0000">D</FONT>', 
									Script => "admin.pl", 
									Action=>"DeleteGameComment", 
									Action2=>$_[0], 
									Special=>$ref->[4], 
									Class => ""}, 1)
					: "").
				'</td><td align=left style="border: 1px solid #8596B0">'.$c.'</td></tr>';
	}
	print	"</table>";

	$sth->finish;
	#unless ($ok) { print "Keine Kommentare vorhanden!".br; }
}
sub NewComment {
	unless ($LSC{LOGIN}) {
		print "Um Kommentare schreiben zu knnen, musst Du eingeloggt sein.".br;
		return;
	}
	if ($q->param('kommentar')) {
		return;
	}
	my $nummer=$_[0];
	my $save="$scriptname?League=$LSC{League}&Action=$LSC{Action}&special=$LSC{special}";
	print $q->start_form('post',$save);
	print "Kommentar hinzufuegen:".br, 
			$q->textarea('kommentar','',5,40),br,br,
			$q->submit('submit'),
			end_form;
}
#sub ShowUploads...doppelt {
#	if (!$LSC{uploads}) {
#		return;
#	}
#	my $Spiel = shift;
#	my $out = "";
#	my $drin = 0;
#				for (my $i = 0;  $i <= $LSC{MaxUploadsResultPics}; $i++) {
#					if (-e $LSC{uploadpfad}."League-$Spiel->[12]/LigaScript-$Spiel->[0]-$Spiel->[1].$i.jpg") {
#							$out .=  "<I><B>Screenshots:</B></I>".br unless $drin;
#							$drin = 1;
#							$out .= '<A target="_blank" HREF="'.$LSC{uploadurl}.'League-'.$Spiel->[12].'/LigaScript-'.$Spiel->[0].'-'.$Spiel->[1].'.'.$i.'.jpg">Image for Round '.$i.'</A> (uploaded by '.$Spiel->[3].')'.br;
#					}
#					if (-e $LSC{uploadpfad}."League-$Spiel->[12]/LigaScript-$Spiel->[0]-$Spiel->[2].$i.jpg") {
#							$out .= "<I><B>Screenshots:</B></I>".br unless $drin;
#							$drin = 1;
#							$out .= '<A target="_blank" HREF="'.$LSC{uploadurl}.'League-'.$Spiel->[12].'/LigaScript-'.$Spiel->[0].'-'.$Spiel->[2].'.'.$i.'.jpg">Image for Round '.$i.'</A> (uploaded by '.$Spiel->[4].')'.br;
#					}
#				}
#	unless ($drin) {
#		#print "no uploads.".br;
#	}
#	return $out."<br>".($LSC{AllowAction} ? UploadLink ({Name=>"Upload Screens", Special=>$Spiel->[0]}, 1) : "");
#}

1
