
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




sub Points_TeamAktualisieren {
	my $Team = shift || return;
	my $League = shift || $LSC{League} || return;

	Require("LSCStrafpunkte.pm");
	my $punish = StrafpunkteTeamLiga($Team, $League);

	$Team = $LSC{MySQL}->quote($Team);
	$League = $LSC{MySQL}->quote($League);
	my $sth;

	#einfache Punkte

	#home
	$sth = $LSC{MySQL}->prepare("
			SELECT Count(*), Sum(G.Points), Sum(G.LP), Sum(G.Won), Sum(G.Lost), Sum(G.Draw), Sum(D.Special), Sum(G.PPoints1), Sum(G.PPoints2), Sum(G.Vote), Count(G.Vote)
			FROM lsc_games G, lsc_games_daten D WHERE  D.League=$League and D.No=G.Game and G.Team=$Team and G.Home=1 Group by G.Team");
	
	$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
    
	my $homesimpel = $sth->fetchrow_arrayref();
	$homesimpel = [0,0,0,0,0,0,0,0,0,0,0,0] if !$homesimpel || !$homesimpel->[0]; 
	$sth->finish();

	$sth = $LSC{MySQL}->prepare("
			SELECT Count(*), Sum(G2.Points), Sum(G2.LP)
			FROM lsc_games_daten D, lsc_games G, lsc_games G2  WHERE  D.League=$League and 
																		D.No=G.Game	and G.Team=$Team and G.Home=1 and
																		D.No=G2.Game and G2.Home=0 
																		Group by G.Team");
	
	$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
    
	my $homesimpel2 = $sth->fetchrow_arrayref();
	$homesimpel2->[1] = 0 if !$homesimpel2->[1];
	$homesimpel2->[0] = 0 if !$homesimpel2->[0];
	$homesimpel2->[2] = 0 if !$homesimpel2->[2];
	$sth->finish();
	if ($homesimpel->[0] != $homesimpel2->[0]) {
		print "unterschiedliche anzahl spiele bei home und away".br;
	}

	#away
	$sth = $LSC{MySQL}->prepare("
			SELECT Count(*), Sum(G.Points), Sum(G.LP), Sum(G.Won), Sum(G.Lost), Sum(G.Draw), Sum(D.Special), Sum(G.PPoints1), Sum(G.PPoints2), Sum(G.Vote), Count(G.Vote)
			FROM lsc_games G, lsc_games_daten D WHERE  D.League=$League and D.No=G.Game and G.Team=$Team and G.Home=0 Group by G.Team");
	
	$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
    
	my $awaysimpel = $sth->fetchrow_arrayref();
	$awaysimpel = [0,0,0,0,0,0,0,0,0,0,0,0] if !$awaysimpel || !$awaysimpel->[0]; 
	$sth->finish();

	$sth = $LSC{MySQL}->prepare("
			SELECT Count(*), Sum(G2.Points), Sum(G2.LP)
			FROM lsc_games_daten D, lsc_games G, lsc_games G2  WHERE  D.League=$League and 
																		D.No=G.Game	and G.Team=$Team and G.Home=0 and
																		D.No=G2.Game and G2.Home=1 
																		Group by G.Team");
	
	$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
    
	my $awaysimpel2 = $sth->fetchrow_arrayref();
	$awaysimpel2->[1] = 0 if !$awaysimpel2->[1];
	$awaysimpel2->[0] = 0 if !$awaysimpel2->[0];
	$awaysimpel2->[2] = 0 if !$awaysimpel2->[2];
	$sth->finish();
	if ($awaysimpel->[0] != $awaysimpel2->[0]) {
		print "unterschiedliche anzahl spiele bei home und away".br;
	}

	#letzten 10 spiele

	$sth = $LSC{MySQL}->prepare("
			SELECT G.Won, G.Lost, G.Draw 
			FROM lsc_games G, lsc_games_daten D WHERE  D.League=$League and D.No=G.Game and G.Team=$Team
			order by D.Date desc Limit 10");
	
	$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
    
	my $last10 = [0,0,0]; 
	while (my @l= $sth->fetchrow_array()) {
		$last10->[0] += $l[0];
		$last10->[1] += $l[1];
		$last10->[2] += $l[2];
	}
	$sth->finish();

	#group results
		#main und sub group vorhanden?
		$sth = $LSC{MySQL}->prepare("
			SELECT Main_Group, Sub_Group 
			FROM lsc_teams_league WHERE Team=$Team and League=$League");
	
		$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
		my @teamgroups = $sth->fetchrow_array();
		$sth->finish();
		my $maingroup = [0,0,0]; 
		if ($teamgroups[0]) {
			#maingroup
			my @teams;
			$sth = $LSC{MySQL}->prepare("
				SELECT Team 
				FROM lsc_teams_league WHERE League=$League and Main_Group=$teamgroups[0] and Team<>$Team");
	
			$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
			while (my $ref = $sth->fetchrow_arrayref()) {
				push @teams, $ref->[0];
			}
			$sth->finish();		
			$teams[0] = 0 if !$teams[0];
			$sth = $LSC{MySQL}->prepare("
				SELECT Sum(G.Won), Sum(G.Lost), Sum(G.Draw) 
				FROM lsc_games_daten D, lsc_games G, lsc_games G2  WHERE  D.League=$League and 
																		D.No=G.Game	and G.Team=$Team and
																		D.No=G2.Game and G2.Team in (".(join(',', @teams)).")
																		Group by G.Team");
	
			$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
    
			$maingroup = $sth->fetchrow_arrayref() || [0,0,0]; 
			$sth->finish();
		}
		my $subgroup = [0,0,0]; 
		if ($teamgroups[1]) {
			#subgroup
			my @teams;
			$sth = $LSC{MySQL}->prepare("
				SELECT Team 
				FROM lsc_teams_league WHERE League=$League and Sub_Group=$teamgroups[1] and Team<>$Team");
	
			$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
			while (my $ref = $sth->fetchrow_arrayref()) {
				push @teams, $ref->[0];
			}
			$sth->finish();		
			$teams[0] = 0 if !$teams[0];
			$sth = $LSC{MySQL}->prepare("
				SELECT Sum(G.Won), Sum(G.Lost), Sum(G.Draw) 
				FROM lsc_games_daten D, lsc_games G, lsc_games G2  WHERE  D.League=$League and 
																		D.No=G.Game	and G.Team=$Team and
																		D.No=G2.Game and G2.Team in (".(join(',', @teams)).")
																		Group by G.Team");
			$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
    
			$subgroup = $sth->fetchrow_arrayref() || [0,0,0]; 
			$sth->finish();
		}

	#streak
	my @streak = (0,0,0,0,0);
	if ($homesimpel->[0] || $awaysimpel->[0]) {
		$sth = $LSC{MySQL}->prepare("
				SELECT G.Won, G.Lost, G.Draw 
				FROM lsc_games G, lsc_games_daten D WHERE  D.League=$League and D.No=G.Game and G.Team=$Team
				order by D.Date asc");
		$sth->execute();

	#CurrentStreak  CurrentStreakC  LongestStreakW  LongestStreakL  LongestStreakD  
		my $last = -1;
		my $count = 0;
		while (my $ref = $sth->fetchrow_arrayref()) {
			if ($ref->[0]) {
				if ($last == 1) {
					$count++
				} else {
					$streak[$last+1] = $count if ($last > 0 &&
													$streak[$last+1] < $count);
					$last = 1;
					$count = 1;
				}
			} elsif ($ref->[1]) {
				if ($last == 2) {
					$count++
				} else {
					$streak[$last+1] = $count if ($last > 0 &&
													$streak[$last+1] < $count);
					$last = 2;
					$count = 1;
				}
			} else {
				if ($last == 3) {
					$count++
				} else {
					$streak[$last+1] = $count if ($last > 0 &&
													$streak[$last+1] < $count);
					$last = 3;
					$count = 1;
				}
			}
		}
		$streak[$last+1] = $count if ($last > 0 &&
							$streak[$last+1] < $count);
		$streak[0] = $last;
		$streak[1] = $count;
		$sth->finish;
	}

	#HighPointsGame  LowPointsGame  HighWin  HighLost  
	my @games = (0,0,0,0);
		$sth = $LSC{MySQL}->prepare("
				SELECT G.Game 
				FROM lsc_games G, lsc_games_daten D WHERE  D.League=$League and D.No=G.Game and G.Team=$Team
				order by G.Points Desc, D.Date desc Limit 1");
		$sth->execute();

		$games[0] = ($sth->fetchrow_arrayref() || [0])->[0];
		$sth->finish;

		$sth = $LSC{MySQL}->prepare("
				SELECT G.Game 
				FROM lsc_games G, lsc_games_daten D WHERE  D.League=$League and D.No=G.Game and G.Team=$Team
				order by G.Points asc, D.Date desc Limit 1");
		$sth->execute();

		$games[1] = ($sth->fetchrow_arrayref() || [0])->[0];
		$sth->finish;
	
		$sth = $LSC{MySQL}->prepare("
				SELECT G.Game 
				FROM lsc_games_daten D, lsc_games G, lsc_games G2  WHERE  D.League=$League and 
																		D.No=G.Game	and G.Team=$Team and G.Won > 0 and
																		D.No=G2.Game and G2.Team<>$Team
				order by (G.Points-G2.Points) Desc, D.Date desc Limit 1");
		$sth->execute();

		$games[2] = ($sth->fetchrow_arrayref() || [0])->[0];
		$sth->finish;

		$sth = $LSC{MySQL}->prepare("
				SELECT G.Game 
				FROM lsc_games_daten D, lsc_games G, lsc_games G2  WHERE  D.League=$League and 
																		D.No=G.Game	and G.Team=$Team and G.Lost > 0 and
																		D.No=G2.Game and G2.Team<>$Team
				order by (G.Points-G2.Points) asc, D.Date desc Limit 1");
		$sth->execute();

		$games[3] = ($sth->fetchrow_arrayref() || [0])->[0];
		$sth->finish;


	Require("LSCErgebnisse2.all.pm");
	unless (_Ergebnisse_PunkteDefinition_Laden()) {
		print $LSC{TEXT}{Ergebnisse}[38].br;
		return undef;
	}

	#updaten
	#Games  PPoints		MPoints		LP			Won				Lost			Draw  
	#		HomePoints  HomeMPoints	HomeLP		HomeWon			HomeLost		HomeDraw  
	#								Last10Won		Last10Lost		Last10Draw  
	#								MainGroupWon	MainGroupLost	MainGroupDraw  
	#								SubGroupWon		SubGroupLost	SubGroupDraw  
	#CurrentStreak  CurrentStreakC  LongestStreakW  LongestStreakL  LongestStreakD  
	#HighPointsGame  LowPointsGame  HighWin  HighLost  
	my $do = "update lsc_teams_league set
			Games		= ".($homesimpel->[0] +$awaysimpel->[0]).",
			PPoints		= ".($homesimpel->[1] +$awaysimpel->[1]).",
			MPoints		= ".($homesimpel2->[1] +$awaysimpel2->[1]).",
			LP			= ".($homesimpel->[2] +$awaysimpel->[2] +$LSC{LeagueData}{NewGamePoints}{StartPoints}+$punish->{LeaguePoints}).",
			GLP			= ".($homesimpel2->[2] +$awaysimpel2->[2] +$LSC{LeagueData}{NewGamePoints}{StartPoints}).",
			Won			= ".($homesimpel->[3] +$awaysimpel->[3]+$punish->{LeagueWon}).",
			Lost		= ".($homesimpel->[4] +$awaysimpel->[4]+$punish->{LeagueLost}).",
			Draw		= ".($homesimpel->[5] +$awaysimpel->[5]).",
			OT			= ".($homesimpel->[6] +$awaysimpel->[6]).",
			 
			HomePPoints		= $homesimpel->[1],
			HomeMPoints		= $homesimpel2->[1],
			HomeLP			= $homesimpel->[2],
			HomeGLP			= $homesimpel2->[2],
			HomeWon			= $homesimpel->[3],
			HomeLost		= $homesimpel->[4],
			HomeDraw		= $homesimpel->[5],
			HomeOT			= $homesimpel->[6],

			Last10Won		= $last10->[0],
			Last10Lost		= $last10->[1],
			Last10Draw		= $last10->[2],

			MainGroupWon		= $maingroup->[0],
			MainGroupLost		= $maingroup->[1],
			MainGroupDraw		= $maingroup->[2],

			SubGroupWon			= $subgroup->[0],
			SubGroupLost		= $subgroup->[1],
			SubGroupDraw		= $subgroup->[2],

			CurrentStreak		= $streak[0],
			CurrentStreakC  	= $streak[1],
			LongestStreakW  	= $streak[2],
			LongestStreakL  	= $streak[3],
			LongestStreakD		= $streak[4],

			HighPointsGame		= $games[0],
			LowPointsGame  		= $games[1],
			HighWin  			= $games[2],
			HighLost			= $games[3],

			PPoints1			= ".($homesimpel->[7] +$awaysimpel->[7]).",
			PPoints2			= ".($homesimpel->[8] +$awaysimpel->[8]).",
 
			Vote				= ".$LSC{MySQL}->quote($homesimpel->[10] +$awaysimpel->[10] > 0 ? ($homesimpel->[9] +$awaysimpel->[9])/($homesimpel->[10] +$awaysimpel->[10]) : 0).",
			VoteCount			= ".(($homesimpel->[10]||0) +($awaysimpel->[10]||0))."

			where Team=$Team and League=$League";
			$sth = $LSC{MySQL}->prepare($do);
			$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
}
sub Points_PunkteLaden {
		my $Team = $LSC{MySQL}->quote(shift || 0);
		my $League = $LSC{MySQL}->quote(shift || $LSC{League});

		my $sth = $LSC{MySQL}->prepare("SELECT * from lsc_teams_league where Team=$Team and League=$League");
		if ($sth->execute()) {
			my $ref = $sth->fetchrow_hashref();
			$sth->finish;

			if ($ref) {
				return $ref;
			}
		} 
		return undef;
}
sub Tabelle2PlatzierungUpdaten {
	my $Team = shift || return;
	my $League = shift || $LSC{League} || return;
	my $Rank = shift || return;
	$Team = $LSC{MySQL}->quote($Team);
	$League = $LSC{MySQL}->quote($League);

	my @do;
	push @do, "Rank=$Rank->{1}" if defined($Rank->{1});
	push @do, "Rank2=$Rank->{2}" if defined($Rank->{2});
	push @do, "Rank3=$Rank->{3}" if defined($Rank->{3});

	if ($do[0]) {
		my $do = "update lsc_teams_league set ".
			join(", ", @do).
			" ".
			"where Team=$Team and League=$League";
		my $sth = $LSC{MySQL}->prepare($do);
		$sth->execute or (print "Folgender Fehler ist aufgetrehten: ".$sth->errstr.br);
	}
}



1