
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.0.1 BETA!                         #
# First-Released: August 1999                                                 #
# Distributed by: http://leagues.ihoax.de                                     #
# =========================================================================== #
# Copyright (c) 2000-2003 Joerg Nass (www.ihoax.de) - All Rights Reserved.    #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################


sub SupportNewTicketGame {
	unless ($LSC{SupportTicketFunktion}) {
		print $LSC{TEXT}{ERROR}[9].br;
		return;
	}
}

sub SupportNewTicketWait {
	unless ($LSC{SupportTicketFunktion}) {
		print $LSC{TEXT}{ERROR}[9].br;
		return;
	}
	my ($Action, $ForderungsID) = @_;
	Require("LSCErgebnisse2.all.pm");
	my $F = {};
	print TemplateShow($LSC{Templates}{'SupportInfo'}, {});
	if (!$ForderungsID || !($F=ForderungLaden($ForderungsID))) {
		print $LSC{TEXT}{Forderung}[53].br;
		return;
	}
	my $TeamAdmin = $LSC{userteamid} || ChiefFuerEinTeamInLiga($LSC{userid}, $LSC{League}) || LeaderFuerEinTeamInLiga($LSC{userid}, $LSC{League}) || 0;
	if ($TeamAdmin && ($TeamAdmin eq $F->{F_Team1} || $TeamAdmin eq $F->{F_Team2})) {
		#ok
	} else {
		print $LSC{TEXT}{Support}[3].br; 
		return;
	}
	if ($q->param('submit') && $q->param('Text') && $q->param('Subject')) {
		my $ticket = {};
			$ticket->{League} = $LSC{League} ;
			$ticket->{UserID} = $LSC{userid}; 
			$ticket->{Subject} = $q->param('Subject');
			$ticket->{Text} = $q->param('Text'); 
			$ticket->{WaitingID} = $ForderungsID; 
			$ticket->{GameID} = 0;
			$ticket->{TeamID1} = $TeamAdmin;
 			$ticket->{TeamID2} = 0;
			$ticket->{UserID1} = 0;
			$ticket->{UserID2} = 0;
			if (_SupportNewTicketCreate($ticket)) {
				print br.br."<B>$LSC{TEXT}{Support}[1]</B>".br;
				return;
			}
			print br.br."<B>$LSC{TEXT}{Support}[2]</B>".br;
	}
	print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=&special=$ForderungsID");
	_SupportForm();
	print br.'<div align="center">'.$LSC{TEXT}{Support}[0].'</div>';

	print $q->endform();
}

sub SupportNewTicketGlobal {
	unless ($LSC{SupportTicketFunktion}) {
		print $LSC{TEXT}{ERROR}[9].br;
		return;
	}
	my ($Action, $ID) = @_;

	print TemplateShow($LSC{Templates}{'SupportInfo'}, {});

	if ($q->param('submit') && $q->param('Text') && $q->param('Subject')) {
		my $ticket = {};
			$ticket->{League} = $q->param('TicketLeague') || 0;
			$ticket->{UserID} = $LSC{userid}; 
			$ticket->{Subject} = $q->param('Subject');
			$ticket->{Text} = $q->param('Text'); 
			$ticket->{WaitingID} = 0; 
			$ticket->{GameID} = 0;
			$ticket->{TeamID1} = 0;
 			$ticket->{TeamID2} = 0;
			$ticket->{UserID1} = 0;
			$ticket->{UserID2} = 0;
			if (_SupportNewTicketCreate($ticket)) {
				print br.br."<B>$LSC{TEXT}{Support}[1]</B>".br;
				return;
			}
			print br.br."<B>$LSC{TEXT}{Support}[2]</B>".br;
	}

	print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=&special=").($ForderungsID || "");

	my %Leagues = LigaNamen();
	$Leagues{''} = ' <<< global >>> '; 
	my $LigaPulldown =$q->popup_menu(-name=>'TicketLeague', -values=>[sort {"\L$Leagues{$a}" cmp "\L$Leagues{$b}"} keys %Leagues], -labels=>\%Leagues, -default=>$LSC{League});
	print TemplateShow($LSC{Templates}{'SupportLeagueInfo'}, {"LSC-Liga" => $LSC{LeagueData}{Name}, "LSC-Liga-Pulldown" =>$LigaPulldown});

	
	_SupportForm();

	print $q->endform();
}
sub _SupportForm {
	print '<div align="center"><B>Support</B></div>';
	print '<TABLE align="center"><TR><TD><TABLE>';
		print '<TR><TD class=Support><B>Subject:</B> </TD><TD class=Support>'.$q->textfield("Subject", "", 40, 40).'</TD></TR>';
	print '</TABLE>';
	print "<B>Text:</B>".br;
	print $q->textarea("Text", "", 10, 40).br;
	print $q->submit("submit");
	print '</TD></TR></TABLE>';
}
sub _SupportNewTicketCreate {
	my $ticket = shift;
	my $sth = $LSC{MySQL}->prepare("insert into lsc_supportticket (League, UserID, Subject, Text, WaitingID, GameID, Date, TeamID1, TeamID2, UserID1, UserID2, Status) values (?, ?, ?, ?, ?, ?, now(), ?, ?, ?, ?, 0)");

	$sth->execute(
			$ticket->{League}, 
			$ticket->{UserID}, 
			$ticket->{Subject}, 
			$ticket->{Text}, 
			$ticket->{WaitingID}, 
			$ticket->{GameID},
			$ticket->{TeamID1}, 
			$ticket->{TeamID2}, 
			$ticket->{UserID1}, 
			$ticket->{UserID2}
				) and return 1;
	
	return undef;
}

sub _SupportTicketAddComment {
	my $ticket = shift;
	my $sth = $LSC{MySQL}->prepare("insert into lsc_supportticket (League, SupportID, UserID, Subject, Text, Date) values (?, ?, ?, ?, ?, now())");

	if ($sth->execute(
			$ticket->{League}, 
			$ticket->{SupportID},
			$ticket->{UserID}, 
			$ticket->{Subject} || '', 
			$ticket->{Text}, 
				)) {
		
		if (!$ticket->{AdminID} && $LSC{Admin} && $LSC{userid} != $ticket->{UserIDCreate}) {
			#Admin setzen
			my $sth = $LSC{MySQL}->do("update lsc_supportticket set AdminID=$LSC{userid} where ID=".$ticket->{SupportID});
		}
		return 1;
	}
	
	return undef;
}

sub _SupportTicketShowEntry {
	my $Template = shift;
	my $Values = shift;
	my ($Name, undef) = UserNameUndStatusVonID($Values->{UserID} || 0);
	$Name = 'User unknown (UserID: '.($Values->{UserID} || '?').')' unless $Name;
	$Name = UserLink($Name, $Values->{UserID});

	my $out = {};
	
	$out->{"LSC-Head"} = "$Name ".($Values->{Subject} ?  '| '.RemoveHtmlFromText($Values->{Subject}) : "");
	$out->{"LSC-Body"} = RemoveHtmlFromText($Values->{Text});
	$out->{"LSC-Bottom"} = "$Values->{Date}";

	print TemplateMaker($Template, $out);
}
sub SupportTicketShow {
	my ($Action, $ID) = @_;
	my $League = $LSC{League};
	my $UserID = $LSC{userid};
	my $TeamID = $LSC{userteamid} || ChiefFuerEinTeamInLiga($LSC{userid}, $LSC{League}) || LeaderFuerEinTeamInLiga($LSC{userid}, $LSC{League}) || 0;

	my %Teams = TeamsInDenenUserLeaderOderChiefIst($LSC{userid});
	my $TeamIDs = join (",", keys %Teams);


	if ($TeamID <= 0) {
		$TeamID = -1;
	}
	print ShowLink({Name => "Your Tickets", Script => "$LSC{user_pl}", Action => "SupportTicketAll", Class=>"UserMenu"}, 1).br;

	my $Template = TemplateLoad2($LSC{Templates}{'Supportentry'});
	unless ($Template) {
		print "Konnte Template nicht laden! ($!)".br;
		return;
	}

	my $sth = $LSC{MySQL}->prepare("select * from lsc_supportticket where id=? and League=? and SupportID=0 and (? in (UserID,UserID1,UserID2,UserID3) or TeamID1 in ($TeamIDs) or TeamID2 in ($TeamIDs) or TeamID3 in ($TeamIDs) or ".($LSC{Admin} || 0).")");
	my $ref;
	if ($sth->execute($ID, $League, $UserID) && ($ref = $sth->fetchrow_hashref())) {
		my $Admin = "no admin";
		if ($ref->{AdminID}) {
			($Admin, undef) = UserNameUndStatusVonID($ref->{AdminID});
			$Admin = UserLink($Admin, $ref->{AdminID});
		}
		if ($LSC{Admin}) {
			if ($q->param('close')) {
				my $sth = $LSC{MySQL}->do("update lsc_supportticket set Status=1 where ID=".$ID);
				$ref->{Status} = 1;
			} elsif ($q->param('open')) {
				my $sth = $LSC{MySQL}->do("update lsc_supportticket set Status=0 where ID=".$ID);
				$ref->{Status} = 0;
			} elsif ($q->param('delete')) {
				my $sth = $LSC{MySQL}->do("delete from lsc_supportticket where SupportID=".$ID);
				$sth = $LSC{MySQL}->do("delete from lsc_supportticket where ID=".$ID);
				print "<B>SupportTicket removed!</B>".br;
				return;
			} elsif ($q->param('remove')) {
				if ($q->param('DeleteUser')) {
					my $did = $q->param('DeleteUser');
					if ($did eq $ref->{UserID1}) {
						my $sth = $LSC{MySQL}->do("update lsc_supportticket set UserID1=0 where ID=".$ID);
						$ref->{UserID1} = 0;
					} elsif ($did eq $ref->{UserID2}) {
						my $sth = $LSC{MySQL}->do("update lsc_supportticket set UserID2=0 where ID=".$ID);
						$ref->{UserID2} = 0;
					} elsif ($did eq $ref->{UserID3}) {
						my $sth = $LSC{MySQL}->do("update lsc_supportticket set UserID3=0 where ID=".$ID);
						$ref->{UserID3} = 0;
					}
				} elsif ($q->param('DeleteTeam')) {
					my $did = $q->param('DeleteTeam');
					if ($did eq $ref->{TeamID1}) {
						my $sth = $LSC{MySQL}->do("update lsc_supportticket set TeamID1=0 where ID=".$ID);
						$ref->{TeamID1} = 0;
					} elsif ($did eq $ref->{TeamID2}) {
						my $sth = $LSC{MySQL}->do("update lsc_supportticket set TeamID2=0 where ID=".$ID);
						$ref->{TeamID2} = 0;
					} elsif ($did eq $ref->{TeamID3}) {
						my $sth = $LSC{MySQL}->do("update lsc_supportticket set TeamID3=0 where ID=".$ID);
						$ref->{TeamID3} = 0;
					}
				}			
			}
		}

		my ($CreateName, undef) = UserNameUndStatusVonID($ref->{UserID} || 0);
		$CreateName = 'User unknown (UserID: '.($ref->{UserID} || '?').')' unless $CreateName;
		$CreateName = UserLink($CreateName, $ref->{UserID}) if $ref->{UserID};

		print '<table width="100%">';
			print '<tr><td class="Support"><B>SupportTicket:</B> '.($ref->{Status} == 1 ? '<FONT COLOR="#FF0000">closed</FONT>': '<FONT COLOR="#339900">open</FONT>').'</td></tr>';
			print '<tr><td class="Support"><B>Reason:</B> '.RemoveHtmlFromText($ref->{Subject}).'</td></tr>';
			print '<tr><td class="Support"><B>created by:</B> '.$CreateName.' <B>Admin:</B> '.$Admin.'</td></tr>';
			if ($ref->{GameID}) {
				print '<tr><td class="Support"><B>Game:</B> '.RecapLink($LSC{League}, $ref->{GameID}, "show", "Support").'</td></tr>';
			}
			if ($ref->{WaitingID}) {
				print '<tr><td class="Support"><B>open Game:</B> '.ShowLink({Name=>"show", Script=>"$LSC{user_pl}", Action=>"NewGame", Action2=>"Details", Special=>$ref->{WaitingID}, League=>$LSC{League}, Class=>"Support"}).'</td></tr>';
			}
			
			if ($LSC{Admin} && $ref->{Status} == 0) {
#				print "User: ".scalar(@User).br;
				unless ($ref->{UserID1} && $ref->{UserID2} && $ref->{UserID3}) {
					if (!$q->param('kindofsearch') || $q->param('kindofsearch') eq "2") {
						my $UserID;
						print '<tr><td class="Support"><B>Access:</B><br>';
						if ($UserID=TeamSuchen($scriptname, "$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}", 2)) {
							if (!$ref->{UserID1}) {
								my $sth = $LSC{MySQL}->do("update lsc_supportticket set UserID1=".$UserID." where ID=".$ID);
								$ref->{UserID1} = $UserID;
								print "added!";
							} elsif (!$ref->{UserID2}) {
								my $sth = $LSC{MySQL}->do("update lsc_supportticket set UserID2=".$UserID." where ID=".$ID);
								$ref->{UserID2} = $UserID;
								print "added!";
							} elsif (!$ref->{UserID3}) {
								my $sth = $LSC{MySQL}->do("update lsc_supportticket set UserID3=".$UserID." where ID=".$ID);
								$ref->{UserID3} = $UserID;
								print "added!";
							} else {
								print "all slots are in use!";
							}
						}
						print '</td></tr>';
					}
				}
				unless ($ref->{TeamID1} && $ref->{TeamID2} && $ref->{TeamID3}) {
					if (!$q->param('kindofsearch') || $q->param('kindofsearch') eq "3") {
						my $TeamID;
						print '<tr><td class="Support"><B>Access:</B><br>';
						if ($TeamID=TeamSuchen($scriptname, "$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}", 3)) {
							if (!$ref->{TeamID1}) {
								my $sth = $LSC{MySQL}->do("update lsc_supportticket set TeamID1=".$TeamID." where ID=".$ID);
								$ref->{TeamID1} = $TeamID;
								print "added!";
							} elsif (!$ref->{TeamID2}) {
								my $sth = $LSC{MySQL}->do("update lsc_supportticket set TeamID2=".$TeamID." where ID=".$ID);
								$ref->{TeamID2} = $TeamID;
								print "added!";
							} elsif (!$ref->{TeamID3}) {
								my $sth = $LSC{MySQL}->do("update lsc_supportticket set TeamID3=".$TeamID." where ID=".$ID);
								$ref->{TeamID3} = $TeamID;
								print "added!";
							} else {
								print "all slots are in use!";
							}
						}
						print '</td></tr>';
					}
				}			
				if ($q->param('kindofsearch')) {
					print '<tr><td class="Support">';
					print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
					print $q->submit("new search").$q->endform();
					print '</td></tr>';
				}
			}


			# Erlaubte poster anzeigen:
			my @User = ();
			my @Teams = ();
			my %User = ();
			my %Teams = ();
			foreach  ($ref->{UserID1}, $ref->{UserID2}, $ref->{UserID3}) {
				if ($_) {
					my ($Name, undef) = UserNameUndStatusVonID($_);
					push @User, UserLink($Name, $_);
					$User{$_} = $Name;
				}
			}
			foreach  ($ref->{TeamID1}, $ref->{TeamID2}, $ref->{TeamID3}) {
				if ($_) {
					my ($Name, undef) = TeamnameAndUserFromTeamID($_);
					push @Teams,  TeamLink({Name=>$Name, ID=>$_, HideVote=>1, League=>$ref->{League}});
					$Teams{$_} = $Name;
				}
			}
			if (scalar @User) {
				print '<tr><td class="Support"><B>allowed Users:</B> '.join(" / ", @User).'</td></tr>';
			}
			if (scalar @Teams) {
				print '<tr><td class="Support"><B>allowed Teams:</B> '.join(" / ", @Teams).'</td></tr>';
			}
			if ($LSC{Admin} && $ref->{Status} == 0) {
				if (scalar @User || scalar @Teams) {
					print '<tr><td class="Support"><table width="100%"><tr>';
					if (scalar @User) {
						print '<td class="Support">Change-User-Access:<br>';
						# zugriffsrechte ndern...
						print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
						print $q->popup_menu(-name=>'DeleteUser', -values=>[(keys %User)], -Labels=>\%User, -default=>"0");
						print $q->submit("remove");
						print $q->endform();
						print '</td>';
					}
				
					if (scalar @Teams) {
						print '<td class="Support">Change-Team-Access:<br>';
						# zugriffsrechte ndern...
						print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
						print $q->popup_menu(-name=>'DeleteTeam', -values=>[(keys %Teams)], -Labels=>\%Teams, -default=>"0");
						print $q->submit("remove");
						print $q->endform();
						print '</td>';
					}
					print '</tr></table></td></tr>';
				}
			}
		print '</table>'.br;
		_SupportTicketShowEntry($Template, $ref);
	} else {
		print $LSC{TEXT}{Support}[3].br;
		return;
	}
	$sth->finish();

	# neue kommentare?
	my $new = 0;
	if ($q->param('submit') && $q->param('Text')) {
		my $ticket = {};
			$ticket->{League} = $LSC{League} ;
			$ticket->{UserID} = $LSC{userid}; 
			$ticket->{Subject} = RemoveHtmlFromText($q->param('Subject') || "");
			$ticket->{Text} = $q->param('Text'); 
			$ticket->{SupportID} = $ID;
			$ticket->{AdminID} = $ref->{AdminID};
			$ticket->{UserIDCreate} = $ref->{UserID};
			
			if (_SupportTicketAddComment($ticket)) {
				print br.br."<B>$LSC{TEXT}{Support}[4]</B>".br;
				$new=1;
			} else {
				print br.br."<B>$LSC{TEXT}{Support}[5]</B>".br;
			}
	}

	my $sth2 = $LSC{MySQL}->prepare("select * from lsc_supportticket where SupportID=? and League=? order by id");
	my $ref2;
	if ($sth2->execute($ID, $League)) {
		while ($ref2 = $sth2->fetchrow_hashref()) {
			_SupportTicketShowEntry($Template, $ref2);
		}
	} 
	$sth2->finish();

	if (!$new && $ref->{Status} != 1) {
		print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
		_SupportForm();
		print $q->endform();
	}

	if ($LSC{Admin} && $ref->{Status} == 0) {
		print br.br;
		print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
		print "SupportTicket: ";
		print $q->submit("close");
		print $q->endform();

	} elsif ($LSC{Admin} && $ref->{Status} == 1) {
		print br.br;
		print $q->start_form('post',"$scriptname?League=$LSC{League}&Action=$LSC{Action}&Action2=$LSC{Action2}&special=$LSC{special}");
		print "SupportTicket: ";
		print $q->submit("open");
		print $q->submit("delete");
		print $q->endform();
	}

	return 1;

}

sub SupportTicketShowAdmin {
	unless ($LSC{SupportTicketFunktion}) {
		print $LSC{TEXT}{ERROR}[9].br;
		return;
	}
	unless ($LSC{Admin}) {
		print $LSC{TEXT}{ERROR}[11].br;
		return;
	}	

	my ($Action, $ID) = @_;
	if ($Action && $Action eq "show") {
		if (SupportTicketShow("", $ID)) {
			return;
		}
	}


	# Alle Tickets anzeigen:
	my $sth = $LSC{MySQL}->prepare("select id, League, UserID, AdminID, Subject, WaitingID, GameID, Status, Date  from lsc_supportticket where League=? and SupportID=0 order by Status, id");
	my $sth2 = $LSC{MySQL}->prepare("select count(*) from lsc_supportticket where League=? and SupportID=? Group by SupportID");
	my $sth3 = $LSC{MySQL}->prepare("select UserID from lsc_supportticket where League=? and SupportID=? order by id desc limit 1");
	if ($sth->execute($LSC{League}||0)) {
		print '<table width="100%">';
		print '<tr><td class="Support"><B>ID</B></td><td class="Support"><B>Date</B></td><td class="Support"><B>Subject</B></td><td class="Support"><B>submited by</B></td><td class="Support"><B>admin?</B></td><td class="Support"><B>status</B></td></tr>';
		while (my $ref = $sth->fetchrow_arrayref()) {
			my ($Name, undef) = UserNameUndStatusVonID($ref->[2]);
			$Name = UserLink($Name, $ref->[2]);
			
			my $Admin = "no admin";
			my $new = 0;
			if ($ref->[3]) {
				$new = $ref->[3];
				($Admin, undef) = UserNameUndStatusVonID($ref->[3]);
				$Admin = UserLink($Admin, $ref->[3]);
			} else {
				$new = -1;
			}
			my $Link = ShowLink({Name=>($ref->[7] == 1 ? '<FONT COLOR="#FF0000">closed</FONT>': '<FONT COLOR="#339900">open</FONT>'), Script=>"$scriptname", Action=>"SupportTicket", Action2=>"show", Special=>$ref->[0], League=>$LSC{League}, Class=>"Nix"});
			
			my $count = 0;
			my $lastuser = 0;

			if ($sth2->execute($LSC{League}||0, $ref->[0])) {
				my $ref2 = $sth2->fetchrow_arrayref();
				$count = $ref2->[0] || "0";
				$sth2->finish();
			}
			if ($sth3->execute($LSC{League}||0, $ref->[0])) {
				my $ref3 = $sth3->fetchrow_arrayref();
				if ($ref3->[0]) {
					($lastuser, undef) = UserNameUndStatusVonID($ref3->[0]);
					$lastuser = UserLink($lastuser, $ref3->[0]);
					if ($new != $ref3->[0]) {
						$new = -1;
					}
				}
				$sth3->finish();
			}
			print '<tr><td class="Support">'.$ref->[0].'</td><td class="Support">'.$ref->[8].'</td><td class="Support">'.$ref->[4].' ('.$count.'/'.$lastuser.')</td><td class="Support">'.$Name.'</td><td class="Support">'.$Admin.'</td><td class="Support">=&gt'.$Link.($new == -1 ? '(new)' : '').'</td></tr>';
		}
		print '</table>';
	}
	$sth->finish();
}

sub SupportTicketShowUser {
	unless ($LSC{SupportTicketFunktion}) {
		print $LSC{TEXT}{ERROR}[9].br;
		return;
	}
	my ($Action, $ID) = @_;
	my %Teams = TeamsInDenenUserLeaderOderChiefIst($LSC{userid});
	my $Teams = join (",", keys %Teams);

	# Alle Tickets anzeigen:
	my $sth = $LSC{MySQL}->prepare("select id, League, UserID, AdminID, Subject, WaitingID, GameID, Status, Date  from lsc_supportticket where SupportID=0 and (? in (UserID,UserID1,UserID2,UserID3) or TeamID1 in ($Teams) or TeamID2 in ($Teams) or TeamID3 in ($Teams)) order by Status, id");
	my $sth2 = $LSC{MySQL}->prepare("select count(*) from lsc_supportticket where League=? and SupportID=? Group by SupportID");
	my $sth3 = $LSC{MySQL}->prepare("select UserID from lsc_supportticket where League=? and SupportID=? order by id desc limit 1");
	if ($sth->execute($LSC{userid})) {
		print '<table width="100%">';
		print '<tr><td class="Support"><B>ID</B></td><td class="Support"><B>Date</B></td><td class="Support"><B>Subject</B></td><td class="Support"><B>submited by</B></td><td class="Support"><B>admin?</B></td><td class="Support"><B>status</B></td></tr>';
		while (my $ref = $sth->fetchrow_arrayref()) {
			my ($Name, undef) = UserNameUndStatusVonID($ref->[2]);
			$Name = UserLink($Name, $ref->[2]);
			
			my $Admin = "no admin";
			if ($ref->[3]) {
				($Admin, undef) = UserNameUndStatusVonID($ref->[3]);
				$Admin = UserLink($Admin, $ref->[3]);
			}
			my $Link = ShowLink({Name=>($ref->[7] == 1 ? '<FONT COLOR="#FF0000">closed</FONT>': '<FONT COLOR="#339900">open</FONT>'), Script=>"$scriptname", Action=>"SupportTicket", Action2=>"show", Special=>$ref->[0], League=>$ref->[1], Class=>"Nix"});

			my $count = 0;
			my $lastuser = "?";
			if ($sth2->execute($LSC{League}||0, $ref->[0])) {
				my $ref2 = $sth2->fetchrow_arrayref();
				$count = $ref2->[0] || "0";
				$sth2->finish();
			}
			if ($sth3->execute($LSC{League}||0, $ref->[0])) {
				my $ref3 = $sth3->fetchrow_arrayref();
				if ($ref3->[0]) {
					($lastuser, undef) = UserNameUndStatusVonID($ref3->[0]);
					$lastuser = UserLink($lastuser, $ref3->[0]);
				}
				$sth3->finish();
			}

			
			print '<tr><td class="Support">'.$ref->[0].'</td><td class="Support">'.$ref->[8].'</td><td class="Support">'.$ref->[4].' ('.$count.'/'.$lastuser.')</td><td class="Support">'.$Name.'</td><td class="Support">'.$Admin.'</td><td class="Support">=&gt'.$Link.'</td></tr>';
		}
		print '</table>';
	}
	$sth->finish();
}
1