
###############################################################################
# Sources From LigaScript                                                     #
###############################################################################
# LigaScript: Online Ligaverwaltung                                           #
#                                                                             #
# Version:        LigaScript Full Version 2.1.0	                              #
# First-Released: August 1999                                                 #
# Distributed by: http://www.scroax.net                                       #
# =========================================================================== #
# Copyright (c) 2004 Joerg Nass (www.scroax.net) - All Rights Reserved.	      #
# Software by: Joerg Nass                                                     #
# Kontaktinformationen und weiteres sind jeweils auf den angebenen            #
# Homepages zu finden!                                                        #
###############################################################################
#  ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!! ACHTUNG!!!!                #
#  Bitte den Disclaimer und die Nutzungsbedingungen in der Datei              #
#  LSCConfig.pm lesen!                                                        #
#                                                                             #
###############################################################################




# WochenTabelleUebersicht
# WochenTabelle
# LigaBestOfTable



#############
	############## Wochen-Tabellen ###############
#############
my @months = ("Januar","Februar","Maerz","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember");
sub WochenTabelleUebersicht {
	my $out;
	my $CurrentYear = '';
	my $CurrentMonth = '';
	local *PrintLink = sub {
		#P: data
		if ($_[0]->{'Y'} ne $CurrentYear) {
			$CurrentYear = $_[0]->{'Y'};
			$out .= "</table></td><td><table><tr><td><b>\u$LSC{TEXT}{Stats}{x}[2]: $CurrentYear</b></td></tr>\n";
		}
		if ($_[0]->{'M'} ne $CurrentMonth) {
			$CurrentMonth = $_[0]->{'M'};
			my $Link;
			$Link->{Name} = "- ".$months[$_[0]->{'M'} - 1];
			$Link->{League} = $LSC{League};
			$Link->{Action} = 'WeekStandings';
			$Link->{Action2} = 'month';
			$Link->{Special} = "$CurrentYear-$_[0]->{'M'}";

			$out .= "<tr><td>".ShowLink($Link)."</td></tr>\n";
		}
		my $Link;
		$Link->{Name} = "\u$LSC{TEXT}{Stats}{x}[1] ".$_[0]->{'W'}." ($_[0]->{'Anzahl'})";
		$Link->{League} = $LSC{League};
		$Link->{Action} = 'WeekStandings';
		$Link->{Action2} = 'week';
		$Link->{Special} = "$CurrentYear-$CurrentMonth-$_[0]->{'W'}";

		$out .= "<tr><td></td><td>".ShowLink($Link)."</td></tr>\n";
	};
	my $select	= "Count(No) as Anzahl, Week(Date,1) as W, Month(Date) as M, Year(Date) as Y";
	my $from	= "lsc_games_daten";
	my $where	= "League=$LSC{League}";
	my $group	= "Group by Concat(Year(Date),'-',Week(Date,1))";
	my $order	= "Order by Date DESC";
	my $sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
	$sth->execute();

	while (my $ref = $sth->fetchrow_hashref()) {
		PrintLink($ref);
	}
	$sth->finish;
	
	if ($out) {
		printtext($LSC{TEXT}{Stats}{x}[3],"<table width=100%><tr><td><table>".$out."</table></td></tr></table>");
	} else {
		print $LSC{TEXT}{Stats}{x}[4];
	}
}

sub WochenTabelle {
	#Action2, special
	my ($Year, $Month, $Week) = split(/\-/, $_[1]);
	my $team_Class = 'S12';
	my $wert_Class = 'S12';
	my $out = '<Table border=0 align=center CELLSPACING="0" CELLPADDING="2">';
	$out .= '<tr><td class='.$TableHeaderClass.' width=200>Team/Name</td>';
	$out .= '<td class='.$TableHeaderClass.'>Victories</td>';
	$out .= '<td class='.$TableHeaderClass.'>&nbsp;Defeats</td>';
	$out .= '<td class='.$TableHeaderClass.'>&nbsp;Games</td></tr>';

	my $sth;
	my $Headline;
	my ($select,$from,$where,$group,$order);
	if ($_[0] eq 'week') {
			$select	= "T.Name as Name, G.Team as T_ID, SUM(G.Won) as W, SUM(G.Lost) as L, Count(G.Team)-SUM(G.Lost)-SUM(G.Won) as D";
			$from	= "lsc_games G, lsc_games_daten D, lsc_teams T";
			$where	= "D.No=G.Game and D.League=$LSC{League} 
					and WEEK(D.Date,1)=$Week 
					and Year(D.Date)=$Year 
					and G.Team=T.ID ";
			$group	= "Group by G.Team";
		$order	= "Order by W DESC, L ASC, D DESC";

		$Headline = "$LSC{TEXT}{Stats}{WeekStandings}[1] - Week $Week - $Year";
	} elsif ($_[0] eq 'month') {
			$select	= "T.Name as Name, G.Team as T_ID, SUM(G.Won) as W, SUM(G.Lost) as L, Count(G.Team)-SUM(G.Won)-SUM(G.Lost) as D";
			$from	= "lsc_games G, lsc_games_daten D, lsc_teams T";
			$where	= "D.No=G.Game and D.League=$LSC{League} 
					and Month(D.Date)=$Month 
					and Year(D.Date)=$Year 
					and G.Team=T.ID ";
			$group	= "Group by G.Team";
		$order	= "Order by W DESC, L ASC, D DESC";
		$Headline = "Weekly and monthly statistics - $months[$Month - 1] $Year";
	}
	if ($Headline) {
		$sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order");
		$sth->execute();
		my $i = 0;
		while (my $ref = $sth->fetchrow_hashref()) {
			my $layout =  $TableLayout[$i++ % 2];
			my $Total = $ref->{'W'} + $ref->{'L'} + $ref->{'D'};
			my $Prozent = Round(100/$Total*$ref->{'W'});
			
			$out .= "<tr><td $layout>".TeamLink($ref->{'Name'}, $ref->{'T_ID'}, 'Tabelle', !$LSC{Vote}{S}{Statistik}).'</td>';
			$out .= "<td $layout>$ref->{'W'} (".$Prozent.'%)</td>';
			$out .= "<td $layout align=right>$ref->{'L'}</td>";
			$out .= "<td $layout align=right>$Total</td></tr>";
		}
		$out .= "</table>\n";
		$sth->finish;
		printtext($Headline, $out);
	}
	WochenTabelleUebersicht();
}



####### Liga Bestof Tabellen

sub LigaBestOfTable {
	#Action2, special
	my $out;
	my $Link;
		$Link->{Name} = $LSC{TEXT}{Stats}{x}[6];
		$Link->{League} = $LSC{League};
		$Link->{Action} = "LeagueBestOfTable";
		$Link->{Action2} = "offensive";
		$out .= "&nbsp;&nbsp;- ".ShowLink($Link).br."\n";
		$Link->{Name} = $LSC{TEXT}{Stats}{x}[7];
		$Link->{League} = $LSC{League};
		$Link->{Action} = "LeagueBestOfTable";
		$Link->{Action2} = "defensive";
		$out .= "&nbsp;&nbsp;- ".ShowLink($Link).br."\n";
		$Link->{Name} = $LSC{TEXT}{Stats}{x}[8];
		$Link->{League} = $LSC{League};
		$Link->{Action} = "LeagueBestOfTable";
		$Link->{Action2} = "total";
		$out .= "&nbsp;&nbsp;- ".ShowLink($Link).br."\n";
	printtext($LSC{TEXT}{Stats}{x}[5], $out);

	$out = '<Table border=0 align=center CELLSPACING="0" CELLPADDING="2">';
	$out .= '<tr><td class='.$TableHeaderClass.' width=200>'.$LSC{TEXT}{Teamname2}.'</td>';

	my $sth;
	my $Headline = 'Statistik';
	unless ($_[0]) {
		$_[0] = 'offensive';
	}
	if ($_[0] eq 'offensive') {
		$Headline = $LSC{TEXT}{Stats}{x}[6];
		$out .= '<td class='.$TableHeaderClass.'>+</td>';
		$out .= '<td class='.$TableHeaderClass.'>&nbsp;-</td></tr>';

		my ($select,$from,$where,$group,$order);
			$select	= "T.Name as Name, G1.Team as T_ID, AVG(G1.Points) as PPoints, AVG(G2.Points) as OPoints";
			$from	= "lsc_games G1, lsc_games_daten D, lsc_teams T";
			$from .= " LEFT JOIN lsc_games G2 ON G1.Game = G2.Game and G1.ID != G2.ID";
			$where	= "D.No=G1.Game and D.League=$LSC{League} and G1.Team=T.ID ";
			$group	= "Group by G1.Team";
			$order	= "Order by PPoints DESC, OPoints ASC";
		$sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order Limit 0,50");
	} elsif ($_[0] eq 'defensive') {
		$Headline = $LSC{TEXT}{Stats}{x}[7];
		$out .= '<td class='.$TableHeaderClass.'>+</td>';
		$out .= '<td class='.$TableHeaderClass.'>&nbsp;-</td></tr>';

		my ($select,$from,$where,$group,$order);
			$select	= "T.Name as Name, G1.Team as T_ID, AVG(G1.Points) as PPoints, AVG(G2.Points) as OPoints";
			$from	= "lsc_games G1, lsc_games_daten D, lsc_teams T";
			$from .= " LEFT JOIN lsc_games G2 ON G1.Game = G2.Game and G1.ID != G2.ID";
			$where	= "D.No=G1.Game and D.League=$LSC{League} and G1.Team=T.ID ";
			$group	= "Group by G1.Team";
			$order	= "Order by OPoints ASC, PPoints DESC";
		$sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order Limit 0,50");
	} elsif ($_[0] eq 'total') {
		$Headline = $LSC{TEXT}{Stats}{x}[8];
		$out .= '<td class='.$TableHeaderClass.'>Gesamt</td></tr>';
		my ($select,$from,$where,$group,$order);

			$select	= "T.Name as Name, G1.Team as T_ID, AVG(G1.Points)+AVG(G2.Points) as PPoints";
			$from	= "lsc_games G1, lsc_games_daten D, lsc_teams T";
			$from .= " LEFT JOIN lsc_games G2 ON G1.Game = G2.Game and G1.ID != G2.ID";
			$where	= "D.No=G1.Game and D.League=$LSC{League} and G1.Team=T.ID ";
			$group	= "Group by G1.Team";
			$order	= "Order by PPoints DESC";
		$sth = $LSC{MySQL}->prepare("SELECT $select FROM $from WHERE $where $group $order Limit 0,50");
	}
	my $i = 0;
	$sth->execute();
	while (my $ref = $sth->fetchrow_hashref()) {
		my $layout =  $TableLayout[$i++ % 2];
		$out .= "<tr><td $layout>&nbsp;".TeamLink($ref->{'Name'}, $ref->{'T_ID'}, 'Tabelle', !$LSC{Vote}{S}{Statistik}).'</td>';
		$out .= "<td $layout>$ref->{'PPoints'}</td>";
		if ($ref->{'OPoints'}) {
			$out .= "<td $layout align=right>$ref->{'OPoints'}</td>";
		}
		$out .= "</tr>";
	}
	$sth->finish;
	$out .= "</table>\n";
	printtext("$Headline (Top 50)", $out);
}

1
